"createInstance" <-
function (dataFrame) 
{
    Names = names(dataFrame)
    Code = list()
    Text = list()
    getString("doc=loadDocument()")
    getString("rootNode=doc.createElement(\"DandD\")")
    titleId = c(getSeconds(), getSeconds())
    titleId = paste(c("TE", "TJ"), titleId, sep = "")
    getString("titleNode=doc.createElement(\"Title\")")
    getString("titleNode.setAttribute(\"Language\", \"English Japanese\")")
    getString(paste("titleNode.setAttribute(\"Title\", \"", paste(titleId, 
        collapse = " "), "\")", sep = ""))
    getString("rootNode.appendChild(titleNode)")
    introductionId = c(getSeconds(), getSeconds())
    introductionId = paste(c("IE", "IJ"), introductionId, sep = "")
    getString("backGroundNode=doc.createElement(\"BackGround\")")
    getString("introductionNode=doc.createElement(\"Introduction\")")
    getString("introductionNode.setAttribute(\"Id\", \"Introduction\")")
    getString(paste("introductionNode.setAttribute(\"Introduction\", \"", 
        paste(introductionId, collapse = " "), "\")", sep = ""))
    getString("backGroundNode.appendChild(introductionNode)")
    getString("rootNode.appendChild(backGroundNode)")
    getString("dataNode=doc.createElement(\"Data\")")
    getString("relationalNode=doc.createElement(\"Relational\")")
    structureId = paste("S", getSeconds(), sep = "")
    getString(paste("relationalNode.setAttribute(\"Id\", \"", 
        structureId, "\")", sep = ""))
    structureLongNameId = c(getSeconds(), getSeconds())
    structureLongNameId = paste(c("SLE", "SLJ"), structureLongNameId, 
        sep = "")
    getString(paste("relationalNode.setAttribute(\"LongName\", \"", 
        paste(structureLongNameId, collapse = " "), "\")", sep = ""))
    getString("relationalNode.getNodeName()")
    dataVectorId = NULL
    for (i in 1:length(dataFrame)) {
        getString("valueNode=doc.createElement(\"Value\")")
        getString("valueNode.getNodeName()")
        dataVectorId = c(dataVectorId, paste("DV", getSeconds(), 
            sep = ""))
        mes = paste("valueNode.setAttribute(\"RefId\", \"", dataVectorId[i], 
            "\")", sep = "")
        getString(mes)
        getString("relationalNode.appendChild(valueNode)")
    }
    getString("dataNode.appendChild(relationalNode)")
    getString("rootNode.appendChild(dataNode)")
    getString("dataBodyNode=doc.createElement(\"DataBody\")")
    getString("dataBodyNode.getNodeName()")
    j = 1
    codeId = list()
    dataVectorLongNameId = list()
    for (i in 1:length(dataFrame)) {
        getString("dataVectorNode=doc.createElement(\"DataVector\")")
        getString("dataVectorNode.getNodeName()")
        mes = paste("dataVectorNode.setAttribute(\"Id\", \"", 
            dataVectorId[i], "\")", sep = "")
        getString(mes)
        dataVectorLongNameId[[i]] = c(paste("DVLNE", getSeconds(), 
            sep = ""), paste("DVLNJ", getSeconds(), sep = ""))
        mes = paste("dataVectorNode.setAttribute(\"LongName\", \"", 
            paste(dataVectorLongNameId[[i]], collapse = " "), 
            "\")", sep = "")
        getString(mes)
        if (sum(match(class(dataFrame[[i]]), "ordered", 0))) {
            codeId[[j]] = c(paste("CE", getSeconds(), sep = ""), 
                paste("CJ", getSeconds(), sep = ""))
            mes = paste("dataVectorNode.setAttribute(\"Code\", \"", 
                paste(codeId[[j]], collapse = " "), "\")", sep = "")
            getString(mes)
            Code[[j]] = attributes(dataFrame[[i]])$levels
            getString(paste("dataVectorTextNode=doc.createTextNode(\"", 
                paste(as.numeric(dataFrame[[i]]), collapse = " "), 
                "\")", sep = ""))
            getString("dataVectorNode.setAttribute(\"DataType\", \"OrderedCategory\")")
            getString("dataVectorNode.appendChild(dataVectorTextNode)")
            j = j + 1
        }
        else if (sum(match(class(dataFrame[[i]]), "factor", 0))) {
            codeId[[j]] = c(paste("CE", getSeconds(), sep = ""), 
                paste("CJ", getSeconds(), sep = ""))
            mes = paste("dataVectorNode.setAttribute(\"Code\", \"", 
                paste(codeId[[j]], collapse = " "), "\")", sep = "")
            getString(mes)
            Code[[j]] = attributes(dataFrame[[i]])$levels
            getString(paste("dataVectorTextNode=doc.createTextNode(\"", 
                paste(as.numeric(dataFrame[[i]]), collapse = " "), 
                "\")", sep = ""))
            getString("dataVectorNode.appendChild(dataVectorTextNode)")
            j = j + 1
        }
        else if (sum(match(class(dataFrame[[i]]), "logical", 
            0))) {
            getString(paste("dataVectorTextNode=doc.createTextNode(\"", 
                paste(as.numeric(dataFrame[[i]]), collapse = " "), 
                "\")", sep = ""))
            getString("dataVectorNode.setAttribute(\"DataType\", \"Logical\")")
            getString("dataVectorNode.appendChild(dataVectorTextNode)")
        }
        else {
            getString(paste("dataVectorTextNode=doc.createTextNode(\"", 
                paste(dataFrame[[i]], collapse = " "), "\")", 
                sep = ""))
            getString("dataVectorNode.appendChild(dataVectorTextNode)")
        }
        getString("dataBodyNode.appendChild(dataVectorNode)")
    }
    getString("rootNode.appendChild(dataBodyNode)")
    getString("appendixNode=doc.createElement(\"Appendix\")")
    getString("nameNode=doc.createElement(\"Name\")")
    getString(paste("nameNode.setAttribute(\"Id\", \"", structureLongNameId[1], 
        "\")", sep = ""))
    getString(paste("nameTextNode=doc.createTextNode(\"", "Structure 1", 
        "\")", sep = ""))
    getString("nameNode.appendChild(nameTextNode)")
    getString("appendixNode.appendChild(nameNode)")
    getString("nameNode=doc.createElement(\"Name\")")
    getString(paste("nameNode.setAttribute(\"Id\", \"", structureLongNameId[2], 
        "\")", sep = ""))
    getString(paste("nameTextNode=doc.createTextNode(\"", "Structure 1", 
        "\")", sep = ""))
    getString("nameNode.appendChild(nameTextNode)")
    getString("appendixNode.appendChild(nameNode)")
    print(Code)
    print(codeId)
    if (length(Code)) {
        for (i in 1:length(Code)) {
            code = paste("\\\"", Code[[i]], "\\\"", sep = "")
            cat(code)
            getString("codeNode=doc.createElement(\"Code\")")
            getString(paste("codeNode.setAttribute(\"Id\", \"", 
                paste(codeId[[i]][1], collapse = ""), "\")", 
                sep = ""))
            getString(paste("codeTextNode=doc.createTextNode(\"", 
                paste(code, collapse = " "), "\")", sep = ""))
            getString("codeNode.appendChild(codeTextNode)")
            getString("appendixNode.appendChild(codeNode)")
        }
    }
    getString("rootNode.appendChild(appendixNode)")
    getString("doc.appendChild(rootNode)")
    print(1)
    createName(introductionId, c("Introduction", "introJ"))
    createName(titleId, c("Title", "titlej"))
    createName(unlist(dataVectorLongNameId), rep(Names, rep(2, 
        length(dataVectorLongNameId))))
}
