\name{getInstance}
\alias{getInstance}
\title{Get DandD instance from DandD Server}
\description{
  Function to get DandD instance loaded on DandD Server as a text.
}
\usage{
getInstance(file = NULL)
}
\arguments{
  \item{file}{character string naming an output file. If null, the console}
}
\details{
 The DandD instance loaded on the current eDandD Server is flushed
  as a text file.
}
\seealso{
  \code{\link{DandD}}, \code{\link{createInstance}}.
}

\examples{
obj=DandD("AcidRain.dad")  #``AcidRain.dad'' is loaded on DandD Server
getInstance()  #  the current DandD instance is flused out to the console 
}
\keyword{DandD}
\keyword{dad}
\keyword{open}
\keyword{close}
