\name{plot.dad}
\alias{plot.dad}
\title{Functions to Create Textile Plot}
\description{
  Functions to create Textile Plot.
}
\usage{
## S3 method for class 'dad':
plot (dad, piece = 1, line = T, lcol = "gray", point = T, cex = NULL, mag = NULL)
}
\arguments{
  \item{dad}{\code{dad} object.}
	\item{piece}{a piece which you want to see in a Textile Plot Suit.}
	\item{line}{logical value, weft yarns are drawn if "TRUE".}
	\item{lcol}{colour of weft}
	\item{point}{logical value, circles which indicate the number of duplicated valus are shown if "TRUE".}
	\item{cex}{numerical value, font size of all labels.}
	\item{mag}{numerical value, magnitude of the circles.}
}
\details{
  \code{plot.dad} creates a Textile Plots from \code{dad} object.
}
\seealso{
  \code{\link{DandD}}.
}

\examples{
iris.dad=DandD("Iris.dad")   # import a DandD instance and assign it to iris.dad.
plot(iris.dad)               # produce Textile Plot
}
\keyword{DandD}
\keyword{connection}
\keyword{dad}
\keyword{open}
\keyword{close}
