#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <iconv.h>
#include <stddef.h>
#include <string.h>

#include <R.h>

#ifdef WIN32
#include <winsock2.h>
#else
#include <sys/time.h>
#include <time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#endif




void getString(char**, int*, char**, int* ,int*);
void createConnection(char**,int*);
void closeConnection(int*);
int char2int(char);
int readAllByte(char*, int, int*);
int readTwoByte(char*, int*);
void stringMatch(char**, int*, int*);
void getInstance(char**, int*, char**, int*, int*);
int Send(char*, int, int);
int Recv(char*, int, int);


static int sock;
static int flag;
static int flag2;
static int flag3;//getDataVectorAttributes
static int flag4;//getStructureAttributes
static int flag5;//getValueAttributes
static int flag6;//getAttributesByIds

static char* result;
static char** results;
static char*** resultss;//getDataVectorAttributes
static char*** resultss2;//getStructureAttributes
static char*** resultss3;//getValueAttributes
static char*** resultss4;//getAttributesByIds

void getString(char** requestString, int* requestNum, char** resultString, int* resultNum, int* eflag){
	
	char* inbuf=*requestString;
	int messageSize;
	int insize;
	int sendSize;
	int outsize;
	char* buffer4;
	char* buffer5;
	char* outbuf;
	iconv_t cd;
	size_t res;
	char buffer;
	char sendBuffer[256];
	int headerSize;
	int i, j;
	if(flag==1){
		Free(result);
	}
	
	messageSize = strlen(inbuf);

	insize = messageSize;
	insize++;
	
	sendSize = insize * 2;
	
	sprintf(sendBuffer, "%d", sendSize);
	
	headerSize = strlen(sendBuffer);
	insize += headerSize;
	insize++;
	
	buffer4=(char *)R_alloc((long) insize + 1, sizeof(char));
	
	memcpy(buffer4, sendBuffer, headerSize);
	buffer4[headerSize] = '\n';
	
	memcpy(buffer4 + headerSize + 1, inbuf, messageSize);
	buffer4[insize - 1] = '\n';
	buffer4[insize] = '\0';
	//printf("mes=%s[EOM]", buffer4);
	
	buffer5=(char *)R_alloc((long) insize * 2, sizeof(char));
	inbuf = buffer4;
	outbuf = buffer5;
	/*------Send String---------*/
	//printf("insize=%d", insize);
	cd=iconv_open("UTF-16BE","SJIS");
	res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
	iconv_close(cd);
	
	for(i = 0; i < outbuf - buffer5; i++){
		//printf("%x\n", buffer5[i]);
		if(buffer5[i] == 0xffffffa5){
			buffer5[i] =0x5c;
		}
	}
	//printf("res=%d\n",res);
	
	if(res==(size_t)(-1)){(*eflag)=211;return;}
	
	//printf("moji=%d\n", (outbuf - buffer5));
	
	//if(Send(sock, buffer5, outbuf-buffer5, 0) < 0){ (*eflag) = 221; return; }
	if(send(sock, buffer5, outbuf-buffer5, 0) < 0){ (*eflag) = 221; return; }
	//printf("send\n");
	/*-------getString----------*/
	

	if(readTwoByte(&buffer,eflag)<0){
		(*eflag)+=230;
		return;
	}
	//printf("flag=%c",buffer);
	/*-----1(֤ͤʤ)------*/
	if(buffer=='1'){
		//recv(sock,recvBuffer,254,0);
		return ;
	}else if(buffer=='0' || buffer=='2'){
	//}else if(buffer=='2'){
		//int i;
		int innum;
		
		int sum=0;
		
		char* buffer3;
		char* buffer2;
		
		/*--------ʸڤФ------------*/
		if(readTwoByte(&buffer, eflag)<0){
			(*eflag)+=240;
			return;
		}
		innum=0;char2int(buffer);
		while(buffer!='\n'){
			innum=innum*10+char2int(buffer);
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=250;
				return;
			}
		}
		if(innum==0){return;}
		
		(*resultNum)=0;
		
		buffer3=(char *)R_alloc((long) innum, sizeof(char));
		buffer2=(char *)R_alloc((long) innum, sizeof(char));
		
		inbuf=buffer2;
		outbuf=buffer3;
		
		insize=readAllByte(inbuf, innum, eflag);
		sum+=insize;
		outsize=insize;
		//printf("recv\n");
		
		cd=iconv_open("SJIS","UTF-16BE");
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		iconv_close(cd);
		if(res==(size_t)(-1)){(*eflag)=12;return;}
		
		result=(char*)Calloc((size_t) ((outbuf-buffer3)+1)*sizeof(char), char);
		flag=1;
		
		for(i=0;i<outbuf-buffer3;i++){
			result[i+(*resultNum)]=buffer3[i];
		}
		
		*resultNum+=outbuf-buffer3;
		
		(*resultString)=result;
		
		/*result=(char*)Calloc((size_t) (innum+1)*sizeof(char), char);
		for(i=0; i < innum; i++){
			result[i] = buffer2[i];
		}
		result[innum] = '\0';*/
	}
}

void getList(char** requestString1, char** requestString2, int* requestLength, char** resultString, int* eflag){
	
	char* inbuf;
	int insize;
	int outsize;
	char* buffer5;
	char* outbuf;
	int len;
	iconv_t cd;
	size_t res;
	char buffer;
	char* requestString;
	char numberString[10];
	int numberStrlen, requestStrlen1, requestStrlen2;
	int inputLength;
	
	requestStrlen1 = strlen(*requestString1);
	requestStrlen2 = strlen(*requestString2);
	insize = requestStrlen1 + requestStrlen2;
	
	if(flag2==1){
		Free(results);
	}
	
	//printf("%s\n",(*requestString1));
	//printf("%d\n",(*requestLength));
	results=(char**)Calloc((size_t) (*requestLength)+1, char*);
	
	for(len=0; len<(*requestLength); len++){
		/*---------make request--------*/
		insize = requestStrlen1 + requestStrlen2;
		numberStrlen = sprintf(numberString, "%d", len);
		insize += numberStrlen;
		if((requestString =(char *)R_alloc((long) (insize + 1), sizeof(char)))==NULL){
			(*eflag) = 100;
			//printf("1");
			return ;
		}
		inputLength = sprintf(requestString, "%s", (*requestString1));
		inputLength += sprintf(requestString + inputLength, "%s", numberString);
		inputLength += sprintf(requestString + inputLength, "%s", (*requestString2));
		inbuf = requestString;
		//printf("\n\n\n%s\n inputLength=%d\n", inbuf, inputLength);
		//printf("requset=%d\n insize=%d\n\n", strlen(requestString), insize);
		
		outsize = insize*2+2;
		buffer5=(char *)R_alloc((long) outsize+2, sizeof(char));
		outbuf = buffer5;
		/*------Send String---------*/
		
		cd=iconv_open("UTF-16BE","SJIS");
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		iconv_close(cd);
		
		//printf("res=%d\n",res);
		
		if(res==(size_t)(-1)){(*eflag)=211;return;}
		
		if(send(sock,buffer5,outbuf-buffer5,0)<0){(*eflag)=221;return;}
		
		/*-------getString----------*/
		
		if(readTwoByte(&buffer,eflag)<0){
			(*eflag)+=230;
			return;
		}
		/*-----1------*/
		if(buffer=='1'){
			//return 1;
		}else if(buffer=='0' || buffer=='2'){
			int i;
			int innum;
			
			int sum=0;
			
			char* buffer3;
			char* buffer2;
			
			/*--------ʸڤФ------------*/
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=240;
				return;
			}
			innum=0;char2int(buffer);
			while(buffer!='\n'){
				innum=innum*10+char2int(buffer);
				if(readTwoByte(&buffer, eflag)<0){
					(*eflag)+=250;
					return;
				}
			}
			if(innum==0){return;}
			
			buffer3=(char *)R_alloc((long) innum, sizeof(char));
			buffer2=(char *)R_alloc((long) innum, sizeof(char));
			
			inbuf=buffer2;
			outbuf=buffer3;
			
			insize=readAllByte(inbuf, innum, eflag);
			sum+=insize;
			outsize=insize;
			
			cd=iconv_open("SJIS","UTF-16BE");
			res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
			//printf("res3=%d\n",res);
			iconv_close(cd);
			if(res==(size_t)(-1)){(*eflag)=12;return;}
			
			results[len]=(char*)Calloc((size_t) ((outbuf-buffer3)+1)*sizeof(char), char);
			
			
			for(i=0;i<outbuf-buffer3;i++){
				results[len][i]=buffer3[i];
			}
			
			//resultNum=outbuf-buffer3;
			
			resultString[len]=results[len];

			resultString[len][(outbuf-buffer3)]='\0';
			
			//Free(buffer2);
			//Free(buffer3);
			//Free(buffer5);
		}
	}
	flag2=1;
}







void getList2(char** requestString1, char** requestString2, int* requestVector, int* requestLength, char** resultString, int* eflag){
	
	char* inbuf;
	int insize;
	int outsize;
	char* buffer5;
	char* outbuf;
	int len;
	iconv_t cd;
	size_t res;
	char buffer;
	char* requestString;
	char numberString[10];
	int numberStrlen, requestStrlen1, requestStrlen2;
	int inputLength;
	
	requestStrlen1 = strlen(*requestString1);
	requestStrlen2 = strlen(*requestString2);
	insize = requestStrlen1 + requestStrlen2;
	
	if(flag2==1){
		Free(results);
	}
	
	//printf("%s\n",(*requestString1));
	//printf("%d\n",(*requestLength));
	results=(char**)Calloc((size_t) (*requestLength)+1, char*);
	
	for(len=0; len<(*requestLength); len++){
		/*---------make request--------*/
		insize = requestStrlen1 + requestStrlen2;
		numberStrlen = sprintf(numberString, "%d", requestVector[len]);
		insize += numberStrlen;
		if((requestString =(char *)R_alloc((long) (insize + 1), sizeof(char)))==NULL){
			(*eflag) = 100;
			//printf("1");
			return ;
		}
		inputLength = sprintf(requestString, "%s", (*requestString1));
		inputLength += sprintf(requestString + inputLength, "%s", numberString);
		inputLength += sprintf(requestString + inputLength, "%s", (*requestString2));
		inbuf = requestString;
		//printf("\n\n\n%s\n inputLength=%d\n", inbuf, inputLength);
		//printf("requset=%d\n insize=%d\n\n", strlen(requestString), insize);
		
		outsize = insize*2+2;
		buffer5=(char *)R_alloc((long) outsize+2, sizeof(char));
		outbuf = buffer5;
		/*------Send String---------*/
		
		cd=iconv_open("UTF-16BE","SJIS");
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		iconv_close(cd);
		
		//printf("res=%d\n",res);
		
		if(res==(size_t)(-1)){(*eflag)=211;return;}
		
		if(send(sock,buffer5,outbuf-buffer5,0)<0){(*eflag)=221;return;}
		
		/*-------getString----------*/
		
		if(readTwoByte(&buffer,eflag)<0){
			(*eflag)+=230;
			return;
		}
		/*-----1------*/
		if(buffer=='1'){
			//return 1;
		}else if(buffer=='0' || buffer=='2'){
			int i;
			int innum;
			
			int sum=0;
			
			char* buffer3;
			char* buffer2;
			
			/*--------ʸڤEФ------------*/
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=240;
				return;
			}
			innum=0;char2int(buffer);
			while(buffer!='\n'){
				innum=innum*10+char2int(buffer);
				if(readTwoByte(&buffer, eflag)<0){
					(*eflag)+=250;
					return;
				}
			}
			if(innum==0){return;}
			
			buffer3=(char *)R_alloc((long) innum, sizeof(char));
			buffer2=(char *)R_alloc((long) innum, sizeof(char));
			
			inbuf=buffer2;
			outbuf=buffer3;
			
			insize=readAllByte(inbuf, innum, eflag);
			sum+=insize;
			outsize=insize;
			
			cd=iconv_open("SJIS","UTF-16BE");
			res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
			//printf("res3=%d\n",res);
			iconv_close(cd);
			if(res==(size_t)(-1)){(*eflag)=12;return;}
			
			results[len]=(char*)Calloc((size_t) ((outbuf-buffer3)+1)*sizeof(char), char);
			
			
			for(i=0;i<outbuf-buffer3;i++){
				results[len][i]=buffer3[i];
			}
			
			//resultNum=outbuf-buffer3;
			
			resultString[len]=results[len];

			resultString[len][(outbuf-buffer3)]='\0';
			
			//Free(buffer2);
			//Free(buffer3);
			//Free(buffer5);
		}
	}
	flag2=1;
}









void createConnection(char** address, int* eflag){
	
	char buffer;
	struct sockaddr_in addr;
	
#ifdef WIN32
	WSADATA wsadata;
	WORD wversion = MAKEWORD( 2, 0);
	int nError;
	
	//Winsock
	nError = WSAStartup( wversion, &wsadata);
	if( nError) {
		(*eflag)=111;
		return ;
	}
	//WinsockΥСǧ
	if( wversion != wsadata.wVersion) {
		(*eflag)=112;
		return ;
	}
#endif


	
	sock = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	flag=0;
	flag2=0;
	flag3=0;
	flag4=0;
	flag5=0;
	flag6=0;
	if(sock < 0){
		(*eflag)=113;
		return ;
	}
	
	addr.sin_family = AF_INET;
	/* SET IPADDRESS */
	addr.sin_addr.s_addr = inet_addr(*address);
	
	/* SET PORT NUMBER */
	//addr.sin_port = htons(80);
	addr.sin_port = htons(11009);
	
	/* Build Connection with DandDServer */
	if(connect(sock,(struct sockaddr*)&addr,sizeof(addr))<0){
		(*eflag)=114;
		return ;
	}
	/* Catch a flag of beginning of Connection */
	if(readTwoByte(&buffer, eflag)<0){
		return;
	}

	if(buffer!='1'){
		(*eflag)=115;
		return ;
	}
}

int readTwoByte(char* buffer, int* eflag){
	char buffer1[20],buffer2[10];
	char* inbuf=buffer1;
	char* outbuf=buffer2;
	int insize, outsize;
	iconv_t cd;
	size_t res;

	//insize=readAllByte(inbuf,2,eflag);

	//insize=recv(sock,inbuf,2,0);
	
	insize = recv(sock,inbuf,2,0);
	
	if(insize<0){
		(*eflag)=2;
		return -1;
	}
	//printf("insize%d\n",insize);
	outsize=insize;

	cd=iconv_open("SJIS","UTF-16BE");
	res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
	if(res<0){(*eflag)=1;return -1;}
	iconv_close(cd);
	(*buffer)=buffer2[0];
	//printf("ge=%c\n",buffer2[0]);
	return 0;
}

int char2int(char inbuf){
	inbuf&=0x0f;
	return (int)inbuf;
}

int readAllByte(char* inbuf, int readsize, int* eflag){
	int insize=0;
	int recvSize=0;
	char* posi=inbuf;
	while(insize<readsize){
		recvSize=recv(sock,posi+insize,readsize-insize,0);
		insize+=recvSize;
		//printf("%d",recvSize);
		if(recvSize<0){
			(*eflag)=2;
			return -1;
		}
	}
	inbuf[insize]='\0';
	return insize;
}

int Send(char* buffer, int sendSize, int ssflag){
	int sendNum = 0;
	int buf;
	
	while(sendNum < sendSize){
		if((buf = send(sock, buffer, sendSize, 0)) < 0){
			return(-1);
		}
		sendNum += buf;
		sendSize -= buf;
	}
	return 1;
}

void closeConnection(int* eflag){

#ifdef WIN32
	if(closesocket(sock)<0){
		(*eflag)=3;
	}
	WSACleanup();
#else
	if(close(sock)<0){
		(*eflag)=3;
	}
#endif
	return ;
}

void stringMatch(char** longNames, int* length, int* eflag)
{
	int i,j;
	int num = strlen(longNames[0]);
	if(num<0){(*eflag)=-1;return;}
	
	for(i=1;i<(*length);i++){
		if(num > strlen(longNames[i])){
			num = strlen(longNames[i]);
		}
	}
	for(j=0;j<(*length);j++){
		for(i=0;i<num;i++){
			if(longNames[0][i] != longNames[j][i]){
				//printf("%d", i);
				longNames[0][i]='\0';
				num=i;
				break;
			}
		}
	}
	//printf("%s\n", longNames[0]);
}

void normalString(char** longNames, int* length, int* eflag){
	int i, j, k, stringLength;
	char* buffer;
	
	for(i=0; i<(*length); i++){
		k = 0;
		stringLength = strlen(longNames[i]);
		if(stringLength > 0){
			buffer = (char *)R_alloc((long) stringLength, sizeof(char));
			for(j=0;j<stringLength;j++){
				if((longNames[i][j] >= '0' && longNames[i][j] <= '9') || (longNames[i][j] >= 'A' && longNames[i][j] <= 'Z') || (longNames[i][j] >= 'a' && longNames[i][j] <= 'z')){
					buffer[k] = longNames[i][j];
					k++;
				}
			}
			buffer[k] = '\0';
			sprintf(longNames[i], "%s", buffer);
		}
	}
	return;
}

void getInstance(char** requestString, int* requestNum, char** fileName, int* resultNum, int* eflag){
	
	FILE *fp;
	char* inbuf=*requestString;
	int insize=*requestNum;
	int outsize=2*insize;
	char* buffer5=(char *)R_alloc((long) outsize, sizeof(char));
	char* outbuf=buffer5;
	iconv_t cd;
	size_t res;
	char buffer;




	//printf("flag=%d\n",flag);
	if(flag==1){
		Free(result);
	}
	

	

	
	/*------Send String---------*/
	
	cd=iconv_open("UTF-16BE","SJIS");
	res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
	iconv_close(cd);
	
	//printf("res=%d\n",res);
	
	if(res==(size_t)(-1)){(*eflag)=211;return;}
	
	if(send(sock,buffer5,outbuf-buffer5,0)<0){(*eflag)=221;return;}
	
	/*-------getString----------*/
	

	if(readTwoByte(&buffer,eflag)<0){
		(*eflag)+=230;
		return;
	}
	/*-----1E֤Eͤʤ)------*/
	if(buffer=='1'){
		//return 1;
	}else if(buffer=='0' || buffer=='2'){
		int i, j = 0, tagNumber = 0;
		int innum;
		
		char* buffer2;
		char* buffer3;
		char* buffer4;
		
		/*--------ʸڤEФ------------*/
		if(readTwoByte(&buffer, eflag)<0){
			(*eflag)+=240;
			return;
		}
		innum=0;char2int(buffer);
		while(buffer!='\n'){
			innum=innum*10+char2int(buffer);
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=250;
				return;
			}
		}
		if(innum==0){return;}
		
		buffer3=(char *)R_alloc((long) innum, sizeof(char));
		buffer2=(char *)R_alloc((long) innum, sizeof(char));
		
		if((fp = fopen(*fileName, "w")) < 0){
			printf("file cannot open!");
		}		
		
		inbuf=buffer2;
		outbuf=buffer3;
		
		insize=readAllByte(inbuf, innum, eflag);
		//printf("insize=%d\n",insize);
		//printf("innum=%d\n",innum);
		outsize=insize;
		
		
		/*SJIŜ*/
		result=(char*)Calloc((size_t) (insize*2)*sizeof(char), char);
		flag=1;
		result[0] = buffer2[0];
		j = 1;
		for(i = 1; i < insize; i++){
			if(buffer2[i] == '<'){
				result[j] = '\n';
				result[j+1]=buffer2[i];
				//result[j+1] = '\r';
				j++;
				tagNumber++;
			}else{
				result[j]=buffer2[i];
			}
			j++;
		}
		
		fwrite(result, 1, j, fp);
		
		
		
		/*
		if((cd=iconv_open("SJIS","UTF-16BE")) < 0){(*eflag)=13;return;}
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		iconv_close(cd);
		if(res==(size_t)(-1)){(*eflag)=12;return;}
		
		result=(char*)Calloc((size_t) ((outbuf-buffer3)*2)*sizeof(char), char);
		flag=1;
		

		
		//fwrite(buffer3, outbuf -  buffer3, 1, fp);
		
		for(i=0;i<outbuf-buffer3;i++){
			if(buffer3[i] == '>'){
				result[j]=buffer3[i];
				result[j+1] = '\r';
				result[j+2] = '\n';
				j += 3;
				tagNumber++;
			}else{
				result[j]=buffer3[i];
			}
			j++;
		}
		
		result[j] = '\0';
		//fwrite(result, j, 1, fp);
		buffer4=(char *)R_alloc((long) j*2, sizeof(char));
		
		inbuf = result;
		outbuf = buffer4;
		
		insize = j;
		outsize = j*2;
		
		if((cd=iconv_open("UTF-16BE", "SJIS")) < 0){(*eflag)=13;return;}
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		//printf("res3=%d\n",res);
		iconv_close(cd);
		
		//fwrite(buffer4, outbuf - buffer4, 1, fp);
		//fprintf(fp, buffer4);*/
		fclose(fp);
	}
}


void flushDocument(char** requestString, int* requestNum, char** resultString, int* resultNum, int* eflag){
	
	char* inbuf=*requestString;
	int insize=*requestNum;
	int outsize=2*insize;
	char* buffer5=(char *)R_alloc((long) outsize, sizeof(char));
	char* outbuf=buffer5;
	iconv_t cd;
	size_t res;
	char buffer;




	//printf("flag=%d\n",flag);
	if(flag==1){
		Free(result);
	}
	

	

	
	/*------Send String---------*/
	
	cd=iconv_open("UTF-16BE","SJIS");
	res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
	iconv_close(cd);
	
	//printf("res=%d\n",res);
	
	if(res==(size_t)(-1)){(*eflag)=211;return;}
	
	if(send(sock,buffer5,outbuf-buffer5,0)<0){(*eflag)=221;return;}
	
	/*-------getString----------*/
	

	if(readTwoByte(&buffer,eflag)<0){
		(*eflag)+=230;
		return;
	}
	/*-----1E֤Eͤʤ)------*/
	if(buffer=='1'){
		//return 1;
	}else if(buffer=='0' || buffer=='2'){
		int i, j = 0, tagNumber = 0;
		int innum;
		
		char* buffer2;
		char* buffer3;
		char* buffer4;
		
		/*--------ʸڤEФ------------*/
		if(readTwoByte(&buffer, eflag)<0){
			(*eflag)+=240;
			return;
		}
		innum=0;char2int(buffer);
		while(buffer!='\n'){
			innum=innum*10+char2int(buffer);
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=250;
				return;
			}
		}
		if(innum==0){return;}
		
		buffer3=(char *)R_alloc((long) innum, sizeof(char));
		buffer2=(char *)R_alloc((long) innum, sizeof(char));
		
		
		inbuf=buffer2;
		outbuf=buffer3;
		
		insize=readAllByte(inbuf, innum, eflag);
		//printf("insize=%d\n",insize);
		//printf("innum=%d\n",innum);
		outsize=insize;
		
		
		/*SJIŜ*/
		result=(char*)Calloc((size_t) (insize*2)*sizeof(char), char);
		flag = 1;
		result[0] = buffer2[0];
		j = 1;
		for(i = 1; i < insize; i++){
			if(buffer2[i] == '<'){
				result[j] = '\n';
				result[j+1]=buffer2[i];
				//result[j+1] = '\r';
				j++;
				tagNumber++;
			}else if(buffer2[i] == '&' && buffer2[i+1] == 'q' && buffer2[i+2] == 'u' && buffer2[i+3] == 'o' 
			  && buffer2[i+4] == 't' && buffer2[i+5] == ';'){
				result[j] = '\"';
				i += 5;
			}else{
				result[j]=buffer2[i];
			}
			j++;
		}
		(*resultString) = result;
	}
}





#ifdef WIN32
static char secondsBuffer[33];
void getSeconds(char** seconds, int* eflag)
{
	SYSTEMTIME		stime;
	double second;
	
	
	GetLocalTime(&stime);
	
	second = (((((((((double)stime.wYear-1999)*12 + (double)stime.wMonth)*31) + (double)stime.wDay)*24) 
		+ (double)stime.wHour)*60 + (double)stime.wMinute)*60 + (double)stime.wSecond)*1000 + (double)stime.wMilliseconds;
	//second = ((((stime.wHour)*60 + stime.wMinute)*60 + stime.wSecond)*1000 + stime.wMilliseconds)*10;
	//printf("%f\n", second);
	sprintf(secondsBuffer, "%.0f", second);
	(*seconds) = secondsBuffer;
}
#else
static char secondsBuffer[33];
void getSeconds(char** seconds, int* eflag)
{
  struct timeval tv;
  struct timezone tz;
  double second;
  gettimeofday(&tv, &tz);
  second = tv.tv_sec * 100 + tv.tv_usec;
  sprintf(secondsBuffer, "%.0f", second);
  (*seconds) = secondsBuffer;
}
#endif





int sendString(char** buf, int* len, int* eflag){
	
	char *inbuf, *outbuf;
	int messageSize = (*len) + 1;
	char header[65]; 
	int headerSize;
	int sendSize;
	int i;
	char* buffer;
	char* sendString;
	iconv_t cd;
	int insize;
	int outsize;
	
	//printf("%d", *len);
	sprintf(header, "%d\n", messageSize * 2);
	//printf("header = %s\n", header);
	headerSize = strlen(header);
	
	insize = headerSize + messageSize;
	outsize = insize * 2;
	sendSize = outsize;
	
	buffer = (char *)R_alloc((long) (insize + 1), sizeof(char));
	sendString = (char *)R_alloc((long) (outsize + 1), sizeof(char));
	
	if(memcpy(buffer, header, headerSize) == NULL){printf("buffer"); return -1;}
	if(memcpy(buffer + headerSize, (*buf), (*len)) == NULL){printf("buffer"); return -1;}
	if(memcpy(buffer + headerSize + (*len), "\n", 2) == NULL){printf("buffer2"); return -1;}
	
	//printf("outsize = %d\n", outsize);
	//printf("\n%s", buffer);
	
	inbuf = buffer;
	outbuf = sendString;
	

	
	/*------Send String---------*/
	
	
	
	cd=iconv_open("UTF-16BE", "SJIS");
	if( iconv(cd, (const char**)&inbuf, &insize, &outbuf, &outsize) < 0 ){(*eflag) = 1; return -1; }
	iconv_close(cd);
	
	for(i = 0; i < outbuf - sendString; i++){
		if(sendString[i] == 0xffffffa5){
			sendString[i] =0x5c;
		}
	}
	
	if( send(sock, sendString, sendSize, 0) < 0 ){(*eflag) = 1; return -1;}
	
	return 1;
}

int recvString(char** buf, int* sflag, int* eflag){
	
	int recvSize, serverFlag, insize, outsize, headerSize = 1, iconvSize, bodySize, iconvSize2 = 0;
	iconv_t cd;
	char* inbuf;
	char* outbuf;
	char buffer1[257], buffer2[257], buffer[100];
	int i;
	
	
	if(flag == 1){ Free(result); flag = 0; /*printf("%s", result);*/ }
	
	
	/*------Recv String---------*/
	if( (recvSize = recv(sock, buffer1, 256, 0)) < 0 ){printf("recv1\n"); return -1; }
	
	inbuf = buffer1;
	outbuf = buffer2;
	insize = recvSize;
	outsize = insize;
	
	cd = iconv_open("SJIS", "UTF-16BE");
	if(iconv(cd, (const char**)&inbuf, &insize, &outbuf, &outsize) < 0){(*eflag) = 1; return -1; }
	iconv_close(cd);
	
	iconvSize = outbuf - buffer2;
	
	if(sscanf(buffer2, "%1d", &serverFlag) < 0){printf("scan1"); return -1; }
	
	
	/*Server Erorr Flag*/
	//for(i=0; i<strlen(buffer2); i++){
		//printf("mess = %x\n", buffer2[i]);
	//}
	
	if(serverFlag == 1){
		//printf("send mae\n");
		(*sflag) = serverFlag;
		//result = NULL;
		//(*buf) = result;
		return serverFlag;
	}else if(serverFlag == 0 || serverFlag == 2){
		int scanSize, outputNumber;
		
		if(buffer2[1] == '\n'){ return -1;}
		
		if( (scanSize = sscanf(buffer2+1, "%d", &outputNumber)) < 0 ){printf("scan2"); return -1; }
		while(buffer2[headerSize - 1] != '\n'){
			headerSize++;
		}
		
		bodySize = iconvSize - headerSize;
		
		//result = (char *)malloc((bodySize + 1) * sizeof(char));
		
		//result = (char *)R_alloc((long) (outputNumber + 1), sizeof(char));
		result = (char*)Calloc((size_t) (outputNumber + 1) * sizeof(char), char);
		flag = 1;
		
		memcpy(result, buffer2 + headerSize, bodySize);
		//result[bodySize] = '\0';
		
//printf("buf = %s\n", buf);
		
		if( (recvSize - headerSize * 2) < outputNumber ){
			char* buffer3;
			//char buffer3[1470000];
			char* buffer4;
			//buffer4 = (char *)R_alloc((long) innum, sizeof(char));
			//buffer5 = (char *)R_alloc((long) innum, sizeof(char));
			//resultString = (char *)R_alloc((long) outputNumber, sizeof(char));
			buffer3 = (char *)R_alloc((long) (outputNumber)*2, sizeof(char));
			//printf("outputNumber=%d\n", outputNumber);
			buffer4 = (char *)R_alloc((long) (outputNumber + 1), sizeof(char));
			
			insize = outputNumber + headerSize * 2 - recvSize;
			
			if(Recv(buffer3, insize, 0) < 0){ printf("recv2"); return -1; }
			
			inbuf=buffer3;
			outbuf=buffer4;
			outsize=insize;
			
			cd=iconv_open("SJIS","UTF-16BE");
			if( iconv(cd, (const char**)&inbuf, &insize, &outbuf, &outsize) < 0){ return -1; }
			iconv_close(cd);
			
			iconvSize2 = outbuf - buffer4;
			
			memcpy(result + bodySize, buffer4, iconvSize2);
			
			if(result[bodySize + iconvSize2 - 1] == ' '){
				 result[bodySize + iconvSize2 - 1] = '\0';
			}else{
				result[bodySize + iconvSize2] = '\0';
			}
		}else{
			if(result[bodySize - 1] == ' '){
				 result[bodySize - 1] = '\0';
			}else{
				result[bodySize] = '\0';
			}
		}
		
		(*buf) = result;
		//printf("\nresult = %s\n", result);
		(*sflag) = serverFlag;
		return serverFlag;
	}
	return serverFlag;
}

void sendAndRecv(char** sendMessage, char** recvMessage, int* messageLength, int* sflag, int* eflag){
	if(sendString(sendMessage, messageLength, eflag) < 0){
		return;
	}
	if(recvString(recvMessage, sflag, eflag) < 0){
		return;
	}
}
void sendAndRecvLocal(char** sendMessage, char** recvMessage, int* messageLength, int* sflag, int* eflag, char** filename){
	if(sendStringLocal(sendMessage, messageLength, eflag, filename) < 0){
		return;
	}
	if(recvString(recvMessage, sflag, eflag) < 0){
		return;
	}
}


int sendStringLocal(char** buf, int* len, int* eflag, char** filename){
	
	char *inbuf, *outbuf;
	int messageSize = (*len);
	char header[65]; 
	int headerSize;
	int sendSize;
	int i;
	char* buffer;
	char* sendString;
	iconv_t cd;
	int insize;
	int outsize;
	FILE *fp;
	
	
	char kaigyo_j[2], kaigyo_u[3];
	char space_j[2], space_u[3];
	char* kaigyo_jp, *kaigyo_up;
	char* space_jp, *space_up;
	int kaigyoJ, kaigyoU;
	int spaceJ, spaceU;
	
	char* fileString;
	int fileSize=0, bufferSize=100, gyo=0;
	char fileBuffer[101];
	char temp;
	
	kaigyo_j[0]='\n';
	kaigyo_j[1]='\0';
	kaigyo_jp=kaigyo_j;
	kaigyo_up=kaigyo_u;
	kaigyoJ=1;
	kaigyoU=2;
	
	
	space_j[0]=' ';
	space_j[1]='\0';
	space_jp=space_j;
	space_up=space_u;
	spaceJ=1;
	spaceU=2;
	
	
	
	
	cd=iconv_open("UTF-16BE", "SJIS");
	iconv(cd,(const char**)&kaigyo_jp, &kaigyoJ, &kaigyo_up, &kaigyoU);
	iconv_close(cd);
	
	cd=iconv_open("UTF-16BE", "SJIS");
	iconv(cd,(const char**)&space_jp, &spaceJ, &space_up, &spaceU);
	iconv_close(cd);
	
	
	
	fp = fopen(*filename, "r");
	if ( fp == NULL ){
		fprintf(stderr, "t@CI[vł܂B\n");
		return -1;
	}
	
	
	do{
		bufferSize=fread(fileBuffer, 1, 100, fp);
		fileSize = fileSize + bufferSize;
		gyo++;
		//printf("%d", bufferSize);
	}while(bufferSize>0);
	
	//printf("\n%d\n", fileSize);
	fclose(fp);
	
	
	fp = fopen(*filename, "r");
	if ( fp == NULL ){
		fprintf(stderr, "t@CI[vł܂B\n");
		return -1;
	}
	fileString = (char*)malloc( fileSize+1 );
	bufferSize=fread(fileString, 1, fileSize, fp);
	fclose(fp);
	
	for(i = 0; i < fileSize-1; i++){
		if(fileString[i] == 0x00 && fileString[i+1] == 0x0a){
			//printf("%d",i);
			fileString[i] = space_u[0];
			fileString[i+1] = space_u[1];
		}
	}
	
	//if(fileString[0] == 0xff || fileString[0] == 0xfe){/* BIG-ENDIAN*/
		fileString[0] = space_u[0];
		fileString[1] = space_u[1];
	//}
	
	
	
	//printf("%d", *len);
	sprintf(header, "%d\n", fileSize + 2);
	//printf("header = %s\n", header);
	headerSize = strlen(header);
	
	insize = headerSize + messageSize;
	outsize = insize * 2;
	sendSize = outsize;
	
	buffer = (char *)R_alloc((long) (insize + 1), sizeof(char));
	sendString = (char *)R_alloc((long) (outsize + 1 + fileSize + 2), sizeof(char));
	
	//if(memcpy(buffer, header, headerSize) == NULL){printf("buffer"); return -1;}
	//if(memcpy(buffer + headerSize, (*buf), (*len)) == NULL){printf("buffer"); return -1;}
	//if(memcpy(buffer + headerSize + (*len), "\n", 2) == NULL){printf("buffer2"); return -1;}
	
	if(memcpy(buffer, (*buf), (*len)) == NULL){printf("buffer"); return -1;}
	if(memcpy(buffer+(*len), header, headerSize) == NULL){printf("buffer"); return -1;}
	//if(memcpy(buffer + headerSize + (*len), "\n", 2) == NULL){printf("buffer2"); return -1;}
	
	//printf("outsize = %d\n", outsize);
	//printf("\n%s", buffer);
	
	inbuf = buffer;
	outbuf = sendString;
	

	
	/*------Send String---------*/
	
	
	
	cd=iconv_open("UTF-16BE", "SJIS");
	if( iconv(cd, (const char**)&inbuf, &insize, &outbuf, &outsize) < 0 ){(*eflag) = 1; return -1; }
	iconv_close(cd);
	
	
	
	for(i = 0; i < outbuf - sendString; i++){
		if(sendString[i] == 0xffffffa5){
			sendString[i] =0x5c;
		}
	}
	
	for(i = 0; i < fileSize + 2; i=i+2){
		temp = fileString[i];
		fileString[i] = fileString[i+1];
		fileString[i+1] = temp;
	}
	
	
	if(memcpy(outbuf, fileString+2, fileSize-2) == NULL){printf("buffer2"); return -1;}
	
	//*(outbuf + fileSize-2) = 0x00;
	//*(outbuf + fileSize -1) = 0x00;
	
	*(outbuf + fileSize -2) = 0x00;
	*(outbuf + fileSize -1) = 0x0a;
	*(outbuf + fileSize ) = '\0';
	//printf("\n\n%d\n\n", outbuf - sendString);
	//printf("\n\n%d\n\n", fileSize);
	if( send(sock, sendString, (outbuf - sendString) + fileSize , 0) < 0 ){(*eflag) = 1; return -1;}
	
	
	
	/*fp = fopen("C:/test.xml", "w");
	if ( fp == NULL ){
		fprintf(stderr, "t@CI[vł܂B\n");
		return -1;
	}
	fwrite(sendString, 1, sendSize + fileSize, fp);
	fclose(fp);*/
	
	
	
	return 1;
}












void recvString2(char** buf, int* sflag, int* eflag){
	
	int recvSize, serverFlag, insize, outsize, headerSize = 1, iconvSize, bodySize, iconvSize2 = 0;
	iconv_t cd;
	char* inbuf;
	char* outbuf;
	char buffer1[257], buffer2[257];//, buffer[100];
	//int i;
	
	
	
	
	/*------Recv String---------*/
	if( (recvSize = recv(sock, buffer1, 256, 0)) < 0 ){printf("recv1\n"); return; }
	
	inbuf = buffer1;
	outbuf = buffer2;
	insize = recvSize;
	outsize = insize;
	
	cd = iconv_open("SJIS", "UTF-16BE");
	if(iconv(cd, (const char**)&inbuf, &insize, &outbuf, &outsize) < 0){(*eflag) = 1; return; }
	iconv_close(cd);
	
	iconvSize = outbuf - buffer2;
	
	if(sscanf(buffer2, "%1d", &serverFlag) < 0){printf("scan1"); return; }
	
	
	/*Server Erorr Flag*/
	//for(i=0; i<strlen(buffer2); i++){
		//printf("mess = %x\n", buffer2[i]);
	//}
	
	if(serverFlag == 1){
		//printf("send mae\n");
		(*sflag) = serverFlag;
		//result = NULL;
		//(*buf) = result;
		return;
	}else if(serverFlag == 0 || serverFlag == 2){
		int scanSize, outputNumber;
		
		if(buffer2[1] == '\n'){ return;}
		
		if( (scanSize = sscanf(buffer2+1, "%d", &outputNumber)) < 0 ){printf("scan2"); return; }
		while(buffer2[headerSize - 1] != '\n'){
			headerSize++;
		}
		
		bodySize = iconvSize - headerSize;
		
		//result = (char *)malloc((bodySize + 1) * sizeof(char));
		
		//result = (char *)R_alloc((long) (outputNumber + 1), sizeof(char));
		(*buf) = (char*)Calloc((size_t) (outputNumber + 1) * sizeof(char), char);
		
		
		memcpy((*buf), buffer2 + headerSize, bodySize);
		//result[bodySize] = '\0';
		
//printf("buf = %s\n", buf);
		
		if( (recvSize - headerSize * 2) < outputNumber ){
			char* buffer3;
			char* buffer4;
			//buffer4 = (char *)R_alloc((long) innum, sizeof(char));
			//buffer5 = (char *)R_alloc((long) innum, sizeof(char));
			//resultString = (char *)R_alloc((long) outputNumber, sizeof(char));
			buffer3 = (char *)R_alloc((long) (outputNumber + 1), sizeof(char));
			buffer4 = (char *)R_alloc((long) (outputNumber + 1), sizeof(char));
			
			insize = outputNumber + headerSize * 2 - recvSize;
			
			if(Recv(buffer3, insize, 0) < 0){ printf("recv2"); return; }
			
			inbuf=buffer3;
			outbuf=buffer4;
			outsize=insize;
			
			cd=iconv_open("SJIS","UTF-16BE");
			if( iconv(cd, (const char**)&inbuf, &insize, &outbuf, &outsize) < 0){ return; }
			iconv_close(cd);
			
			iconvSize2 = outbuf - buffer4;
			
			memcpy((*buf) + bodySize, buffer4, iconvSize2);
			
			if((*buf)[bodySize + iconvSize2 - 1] == ' '){
				 (*buf)[bodySize + iconvSize2 - 1] = '\0';
			}else{
				(*buf)[bodySize + iconvSize2] = '\0';
			}
		}else{
			if((*buf)[bodySize - 1] == ' '){
				 (*buf)[bodySize - 1] = '\0';
			}else{
				(*buf)[bodySize] = '\0';
			}
		}
		
		//(*buf) = result;
		//printf("\nresult = %s\n", result);
		(*sflag) = serverFlag;
		return;
	}
}














/*-
void getDataVectorAttributes(char** dataVectorId, char** dataType,
	 char** unitLongName, int* len, int* langNum, int* langLength, int* sflag, int* eflag){
	
	int i, j;
	int numberSize, longNameSize;
	int sendSize;
	int headerSize[5], footerSize[5];
	char* sendMessage;
	char* scanFormat = (char*)R_alloc((long) (*langLength) * 4, sizeof(char));
	int scanSize = 0;
	
	char *header[] = {"dataVectorList.item(", "dataVectorList.item(", "dataVectorList.item(", "getValue(doc.getElementById(\""};
	char number[33];
	char *footer[] = {").getAttribute(\"Id\")", ").getAttribute(\"DataType\")", ").getAttribute(\"Unit\")", "\"))"};
	char* longNameId;
	
	if(flag3 != 0){
		for(i = 0; i < 4; i++){
			for(j = 0; j < flag3; j++){
				Free(resultss[i][j]);
			}
			Free(resultss[i]);
		}
		Free(resultss);
	}
	
	resultss = (char***)Calloc((size_t) 5, char**);
	for(j = 0; j < 4; j++){
		resultss[j] = (char**)Calloc((size_t) (*len) + 1, char*);
	}
	flag3 = (*len);
	
	
	for(i = 0; i < 4; i++){
		headerSize[i] = strlen(header[i]);
		footerSize[i] = strlen(footer[i]);
	}
	for(i = 1; i < (*langLength) + 1; i++){
		if((*langNum) == i){
			memcpy(scanFormat + scanSize, "%s ", 3);
			scanSize += 3;
		} else {
			memcpy(scanFormat + strlen(scanFormat), "%*s ", 4);
			scanSize += 4;
		}
	}
	scanFormat[(*langLength)*4 - 2] = '\0';
	printf("%s\n", scanFormat);
	
	for(j = 0; j < (*len); j++){
		for(i = 0; i < 4; i++){
			sprintf(number, "%d", j);
			numberSize = strlen(number);
			if(i == 3){
				if(resultss[i-1][j][0] != '\0'){
					longNameId = (char*)R_alloc((long) strlen(resultss[i-1][j]), sizeof(char));
					sscanf(resultss[i-1][j], scanFormat, longNameId);
					
					longNameSize = strlen(longNameId);
					
					sendSize = headerSize[i] + longNameSize + footerSize[i];
					sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
					memcpy(sendMessage, header[i], headerSize[i]);
					memcpy(sendMessage + headerSize[i], longNameId, longNameSize);
					memcpy(sendMessage + headerSize[i] + longNameSize, footer[i], footerSize[i]);
					sendString(&sendMessage, &sendSize, eflag);
					recvString2(&resultss[i][j], sflag, eflag);
					if (i == 3){
						unitLongName[j] = resultss[i][j];
					}
				}
			} else {
				sendSize = headerSize[i] + numberSize + footerSize[i];
				sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
				
				memcpy(sendMessage, header[i], headerSize[i]);
				memcpy(sendMessage + headerSize[i], number, numberSize);
				memcpy(sendMessage + headerSize[i] + numberSize, footer[i], footerSize[i]);
				sendString(&sendMessage, &sendSize, eflag);
				recvString2(&resultss[i][j], sflag, eflag);
				if(i == 0){
					dataVectorId[j] = resultss[i][j];
				} else if (i == 1) {
					dataType[j] = resultss[i][j];
				}
			}
		}
	}
	
	return;
}
*/













#define ATTRSIZE 8
void getDataStructureAttributes(char** dataStructureId, char** dataStructureLongName, char** dataStructureShortName, char** columns, char** MainKey, char** TargetObject, int* len, int* langNum, int* langLength, int* sflag, int* eflag)
{
	int i, j;
	int numberSize, longNameSize;
	int sendSize;
	int headerSize[ATTRSIZE + 1], footerSize[ATTRSIZE + 1];
	char* sendMessage;
	char* scanFormat = (char*)R_alloc((long) (*langLength) * 4, sizeof(char));
	int scanSize = 0;
	char scan1[] = "%s ";
	char scan0[] = "%*s ";
	
	char *header[] = {"dataStructureList.item(", "dataStructureList.item(", "getValue(doc.getElementById(\"", "dataStructureList.item(", "dataStructureList.item(", "dataStructureList.item(", "dataStructureList.item(", "getValue(doc.getElementById(\""};
	char number[33];
	char *footer[] = {").getAttribute(\"Id\")", ").getAttribute(\"LongName\")", "\"))", ").getAttribute(\"ShortName\")", ").getAttribute(\"PrimaryKey\")", ").getAttribute(\"Columns\")", ").getAttribute(\"TargetObject\")", "\"))"};
	char* longNameId;
	
	if(flag4 != 0){
		for(i = 0; i < ATTRSIZE; i++){
			for(j = 0; j < flag4; j++){
				Free(resultss2[i][j]);
			}
			Free(resultss2[i]);
		}
		Free(resultss2);
	}
	
	resultss2 = (char***)Calloc((size_t) ATTRSIZE + 1, char**);
	for(j = 0; j < ATTRSIZE; j++){
		resultss2[j] = (char**)Calloc((size_t) (*len) + 1, char*);
	}
	flag4 = (*len);
	
	
	for(i = 0; i < ATTRSIZE; i++){
		headerSize[i] = strlen(header[i]);
		footerSize[i] = strlen(footer[i]);
	}
	for(i = 1; i < (*langLength) + 1; i++){
		//printf("%d\n",i);
		if((*langNum) == i){
			memcpy(scanFormat + scanSize, scan1, 3);
			scanSize += 3;
		} else {
			memcpy(scanFormat + scanSize, scan0, 4);
			scanSize += 4;
		}
	}
	scanFormat[(*langLength)*4-2] = '\0';
	
	//printf("st=%s-\n",scanFormat);
	
	for(j = 0; j < (*len); j++){
		for(i = 0; i < ATTRSIZE; i++){
			sprintf(number, "%d", j);
			numberSize = strlen(number);
			if(i == 2 || i == 7){
				if(resultss2[i-1][j][0] != '\0'){
					longNameId = (char*)R_alloc((long) strlen(resultss2[i-1][j]), sizeof(char));
					sscanf(resultss2[i-1][j], scanFormat, longNameId);
					
					longNameSize = strlen(longNameId);
					
					sendSize = headerSize[i] + longNameSize + footerSize[i];
					sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
					memcpy(sendMessage, header[i], headerSize[i]);
					memcpy(sendMessage + headerSize[i], longNameId, longNameSize);
					memcpy(sendMessage + headerSize[i] + longNameSize, footer[i], footerSize[i]);
					sendString(&sendMessage, &sendSize, eflag);
					recvString2(&resultss2[i][j], sflag, eflag);
					if(i == 2){
						dataStructureLongName[j] = resultss2[i][j];
					} else if(i == 7){
						TargetObject[j] = resultss2[i][j];
					}
				}
			} else {
				sendSize = headerSize[i] + numberSize + footerSize[i];
				sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
				
				memcpy(sendMessage, header[i], headerSize[i]);
				memcpy(sendMessage + headerSize[i], number, numberSize);
				memcpy(sendMessage + headerSize[i] + numberSize, footer[i], footerSize[i]);
				sendString(&sendMessage, &sendSize, eflag);
				recvString2(&resultss2[i][j], sflag, eflag);
				if(i == 0){
					dataStructureId[j] = resultss2[i][j];
				} else if (i == 3){
					dataStructureShortName[j] = resultss2[i][j];
				} else if (i == 4){
					MainKey[j] = resultss2[i][j];
				} else if (i == 5){
					columns[j] = resultss2[i][j];
				}
			}
		}
	}
	
	return;
}






















#define DATAVECTORATTRSIZE 12
void getAttributesByIds(char** Ids, char** RefId, char** LongName, char** ShortName, char** Unit, char** Numeral, char** DataType, 
			  int* len, int* langNum, int* langLength, int* sflag, int* eflag){
	
	int i, j;
	int numberSize, longNameSize;
	int sendSize;
	int headerSize[DATAVECTORATTRSIZE + 1], footerSize[DATAVECTORATTRSIZE + 1];
	char* sendMessage;
	char* scanFormat = (char*)R_alloc((long) (*langLength) * 4, sizeof(char));
	int scanSize = 0;
	
	char *header[] = {"requiredNode=doc.getElementById(\"",
						 "", "getValue(doc.getElementById(\"",
						  "", "doc.getElementById(\"", "getValue(doc.getElementById(\"",
						   "", "doc.getElementById(\"", "getValue(doc.getElementById(\"",
						    "", "", ""};
						  
	char *footer[] = {"\")",
					  "requiredNode.getAttribute(\"LongName\")", "\"))",
	                   "requiredNode.getAttribute(\"Unit\")", "\").getChildNodes().getLength()", "\"))",
	                    "requiredNode.getAttribute(\"Numeral\")", "\").getChildNodes().getLength()", "\"))", 
	                     "requiredNode.getAttribute(\"DataType\")",
	                      "requiredNode.getAttribute(\"ShortName\")",
	                       "requiredNode.getAttribute(\"RefId\")"};
	                     
	char* longNameId;
	
	if(flag6 != 0){
		for(i = 0; i < DATAVECTORATTRSIZE; i++){
			for(j = 0; j < flag6; j++){
				Free(resultss4[i][j]);
			}
			Free(resultss4[i]);
		}
		Free(resultss4);
	}
	
	resultss4 = (char***)Calloc((size_t) DATAVECTORATTRSIZE + 1, char**);
	for(j = 0; j < DATAVECTORATTRSIZE; j++){
		resultss4[j] = (char**)Calloc((size_t) (*len) + 1, char*);
	}
	flag6 = (*len);
	
	
	for(i = 0; i < DATAVECTORATTRSIZE; i++){
		headerSize[i] = strlen(header[i]);
		footerSize[i] = strlen(footer[i]);
	}
	for(i = 1; i < (*langLength) + 1; i++){
		if((*langNum) == i){
			memcpy(scanFormat + scanSize, "%s ", 3);
			scanSize += 3;
		} else {
			memcpy(scanFormat + scanSize, "%*s ", 4);
			scanSize += 4;
		}
	}
	scanFormat[(*langLength)*4 - 2] = '\0';
	//printf("dv=%s-\n",scanFormat);
	//printf("kokomade\n");
	
	for(j = 0; j < (*len); j++){
		//printf("%d\n",j);
		numberSize = strlen(Ids[j]);
		for(i = 0; i < DATAVECTORATTRSIZE; i++){
			//printf("i=%d\n",i);
			if(i == 5 || i == 8){
				if(resultss4[i-2][j][0] != '\0'){
					longNameId = (char*)R_alloc((long) strlen(resultss4[i-2][j]), sizeof(char));
					sscanf(resultss4[i-2][j], scanFormat, longNameId);
					
					longNameSize = strlen(longNameId);
					
					sendSize = headerSize[i] + longNameSize + footerSize[i];
					sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
					memcpy(sendMessage, header[i], headerSize[i]);
					memcpy(sendMessage + headerSize[i], longNameId, longNameSize);
					memcpy(sendMessage + headerSize[i] + longNameSize, footer[i], footerSize[i]);
					sendString(&sendMessage, &sendSize, eflag);
					recvString2(&resultss4[i][j], sflag, eflag);
					if (i == 5){
						Unit[j] = resultss4[i][j];
					} else if (i == 8){
						Numeral[j] = resultss4[i][j];
					}
				}
			} else if(i == 2 || i == 4 || i == 7){
				if(resultss4[i-1][j][0] != '\0'){
					longNameId = (char*)R_alloc((long) strlen(resultss4[i-1][j]), sizeof(char));
					sscanf(resultss4[i-1][j], scanFormat, longNameId);
					
					longNameSize = strlen(longNameId);
					
					sendSize = headerSize[i] + longNameSize + footerSize[i];
					sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
					memcpy(sendMessage, header[i], headerSize[i]);
					memcpy(sendMessage + headerSize[i], longNameId, longNameSize);
					memcpy(sendMessage + headerSize[i] + longNameSize, footer[i], footerSize[i]);
					sendString(&sendMessage, &sendSize, eflag);
					recvString2(&resultss4[i][j], sflag, eflag);
					if(i == 2){
						LongName[j] = resultss4[i][j];
					} else if (i == 4){
						if(resultss4[i][j][0] == '0'){
							i++;
							Unit[j] = "";
						}else{
							
						}
					} else if (i == 7){
						if(resultss4[i][j][0] == '0'){
							i++;
							Numeral[j] = "";
						}
					}
				}
			} else if (0) {
				if(resultss4[i-1][j][0] != '\0'){
					longNameId = (char*)R_alloc((long) strlen(resultss4[i-1][j]), sizeof(char));
					sscanf(resultss4[i-1][j], "%s", longNameId);
					
					longNameSize = strlen(longNameId);
					sendSize = headerSize[i] + longNameSize + footerSize[i];
					sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
					memcpy(sendMessage, header[i], headerSize[i]);
					memcpy(sendMessage + headerSize[i], longNameId, longNameSize);
					memcpy(sendMessage + headerSize[i] + longNameSize, footer[i], footerSize[i]);
					sendString(&sendMessage, &sendSize, eflag);
					recvString2(&resultss4[i][j], sflag, eflag);
					//Domain[j] = resultss4[i][j];
				}
			} else {
				if(i == 0){
					sendSize = headerSize[i] + numberSize + footerSize[i];
					sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
					
					memcpy(sendMessage, header[i], headerSize[i]);
					memcpy(sendMessage + headerSize[i], Ids[j], numberSize);
					memcpy(sendMessage + headerSize[i] + numberSize, footer[i], footerSize[i]);
					sendString(&sendMessage, &sendSize, eflag);
					recvString2(&resultss4[i][j], sflag, eflag);
				} else {
					sendSize = footerSize[i];
					sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
					
					memcpy(sendMessage, footer[i], footerSize[i]);
					sendString(&sendMessage, &sendSize, eflag);
					recvString2(&resultss4[i][j], sflag, eflag);
				}
				
				if (i == 9){
					DataType[j] = resultss4[i][j];
				} else if(i == 10){
					ShortName[j] = resultss4[i][j];
				} else if(i == 11){
					RefId[j] = resultss4[i][j];
				}
			}
		}
	}
	
	return;
}























#define VALUEATTRSIZE 2
void getValueAttributes(char** valueRefId, char** systems,
	 int* len, int* langNum, int* langLength, int* sflag, int* eflag){
	
	int i, j;
	int numberSize;//, longNameSize;
	int sendSize;
	int headerSize[VALUEATTRSIZE+1], footerSize[VALUEATTRSIZE+1];
	char* sendMessage;
	char* scanFormat = (char*)R_alloc((long) (*langLength) * 4, sizeof(char));
	int scanSize = 0;
	
	char *header[] = {"valueList.item(", "valueList.item("};
	char number[33];
	char *footer[] = {").getAttribute(\"RefId\")", ").getAttribute(\"Systems\")"};
	//char* longNameId;
	
	if(flag5 != 0){
		for(i = 0; i < VALUEATTRSIZE; i++){
			for(j = 0; j < flag5; j++){
				Free(resultss3[i][j]);
			}
			Free(resultss3[i]);
		}
		Free(resultss3);
	}
	
	resultss3 = (char***)Calloc((size_t) VALUEATTRSIZE+1, char**);
	for(j = 0; j < VALUEATTRSIZE; j++){
		resultss3[j] = (char**)Calloc((size_t) (*len) + 1, char*);
	}
	flag5 = (*len);
	
	for(i = 0; i < VALUEATTRSIZE; i++){
		headerSize[i] = strlen(header[i]);
		footerSize[i] = strlen(footer[i]);
	}
	
	
	
	for(i = 1; i < (*langLength) + 1; i++){
		if((*langNum) == i){
			memcpy(scanFormat + scanSize, "%s ", 3);
			scanSize += 3;
		} else {
			memcpy(scanFormat + strlen(scanFormat), "%*s ", 4);
			scanSize += 4;
		}
	}
	scanFormat[(*langLength)*4 - 2] = '\0';
	
	for(j = 0; j < (*len); j++){
		for(i = 0; i < VALUEATTRSIZE; i++){
			sprintf(number, "%d", j);
			numberSize = strlen(number);
			sendSize = headerSize[i] + numberSize + footerSize[i];
			sendMessage = (char*)R_alloc((long) (sendSize + 1), sizeof(char));
			
			memcpy(sendMessage, header[i], headerSize[i]);
			memcpy(sendMessage + headerSize[i], number, numberSize);
			memcpy(sendMessage + headerSize[i] + numberSize, footer[i], footerSize[i]);
			sendString(&sendMessage, &sendSize, eflag);
			recvString2(&resultss3[i][j], sflag, eflag);
			if (i == 0) {
				valueRefId[j] = resultss3[i][j];
			} else if (i == 1) {
				systems[j] = resultss3[i][j];
			}
		}
	}
	
	return;
}















int Recv(char* buffer, int length, int flags){
	int outsize = 0;
	int recvSize=0;
	char* posi;
	posi = buffer;
	//printf("length=%d\n", length);
	while(outsize < length){
		//printf("length=%d\n", recvSize);
		if( (recvSize = recv(sock, posi + outsize, length - recvSize, flags)) < 0 ){
			return -1;
		}
		outsize += recvSize;
	}
	//printf("outsize=%d\n", outsize);
	//printf("length=%d\n", length);
	buffer[outsize]='\0';
	return outsize;
}


char** digitString;

void flat(int* x, int* n,  char** string){
	int i, nn = (*n);
	
	digitString = (char **)R_alloc((long) nn+1, sizeof(char*));
	
	for(i = 0; i < nn; i++){
		digitString[i] = (char *)R_alloc((long) 5, sizeof(char));
		if(x[i] < 10){
			sprintf(digitString[i], "%d", 0);
			sprintf(digitString[i]+1, "%d", x[i]);
			digitString[i][2] = '\0';
		}else if(x[i] < 100){
			sprintf(digitString[i], "%d", x[i]);
			digitString[i][2] = '\0';
		}else if(x[i] < 1000){
			sprintf(digitString[i], "%d", x[i]);
			digitString[i][3] = '\0';
		}else if(x[i] < 10000){
			sprintf(digitString[i], "%d", x[i]);
			digitString[i][4] = '\0';
		}
		string[i] = digitString[i];
	}
}


