\name{openConn}
\alias{closeConn}
\alias{openConn}
\title{Open and close connection}
\description{
   Function to open and close connection to DandD server
}
\usage{
   openConn(IP="")
   closeConn()
}
\arguments{
  \item{IP}{IP Addrress of DandD server}
}
\references{
  \url{http://stat.math.keio.ac.jp/DandDII/}.
}
\seealso{
 \code{\link{loadDocument}}
}
\examples{\dontrun{
#connect to the DandD server on Peanut
openConn("131.113.65.5")
#load instance
obj=loadDocument("http://www.stat.math.keio.ac.jp/DandDII/Examples/AcidRain.dad")
obj
}
}
\keyword{open}
\keyword{close}
\keyword{socket}
\keyword{DandD}
\keyword{server}

