\name{setDandDServer}
\alias{setDandDServer}
\title{Set IP Address of DandD Server}
\description{
  Function to set IP Address of DandD Server.
}
\usage{
setDandDServer(address = "131.113.65.15")
}
\arguments{
  \item{address}{IP Address of the DandD Server}
}
\details{
  You can choose a DandD Server and set its IP Address to 
  the server descripter \code{.Server}
  stored in \code{package:dad} environment.
}

\value{
  IP Address of DandD Server(character string).
}
\seealso{
  \code{\link{DandD}}, \code{\link{openConn}}, \code{\link{closeConn}}.
}

\examples{
library(dad)
.Server
setDandDServer("127.0.0.1")
.Server
}
\keyword{DandD}
\keyword{dad}
\keyword{open}
\keyword{close}
