#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <iconv.h>
#include <stddef.h>
#include <string.h>
#include <R.h>

#ifdef WIN32
#include <winsock2.h>
#else
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#endif



void getString(char**, int*, char**, int* ,int*);
void createConnection(char**,int*);
void closeConnection(int*);
int char2int(char);
int readAllByte(char*, int, int*);
int readTwoByte(char*, int*);
void stringMatch(char**, int*, int*);
void getInstance(char**, int*, char**, int*, int*);

static int sock;
static int flag;
static int flag2;

static char* result;
static char** results;

void getString(char** requestString, int* requestNum, char** resultString, int* resultNum, int* eflag){
	
	char* inbuf=*requestString;
	int insize=*requestNum;
	int outsize=2*insize;
	char* buffer5=(char *)R_alloc((long) outsize, sizeof(char));
	char* outbuf=buffer5;
	iconv_t cd;
	size_t res;
	char buffer;




	//printf("flag=%d\n",flag);
	if(flag==1){
		Free(result);
	}
	

	

	
	/*-------sendString----------*/
	
	cd=iconv_open("UTF-16BE","SJIS");
	res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
	iconv_close(cd);
	
	//printf("res=%d\n",res);
	
	if(res==(size_t)(-1)){(*eflag)=211;return;}
	
	if(send(sock,buffer5,outbuf-buffer5,0)<0){(*eflag)=221;return;}
	
	/*-------getString----------*/
	

	if(readTwoByte(&buffer,eflag)<0){
		(*eflag)+=230;
		return;
	}
	/*-----1(֤ͤʤ)------*/
	if(buffer=='1'){
		//return 1;
	}else if(buffer=='0' || buffer=='2'){
		int i;
		int innum;
		
		int sum=0;
		
		char* buffer3;
		char* buffer2;
		
		/*--------ʸڤФ------------*/
		if(readTwoByte(&buffer, eflag)<0){
			(*eflag)+=240;
			return;
		}
		innum=0;char2int(buffer);
		while(buffer!='\n'){
			innum=innum*10+char2int(buffer);
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=250;
				return;
			}
		}
		if(innum==0){return;}
		
		(*resultNum)=0;
		
		buffer3=(char *)R_alloc((long) innum, sizeof(char));
		buffer2=(char *)R_alloc((long) innum, sizeof(char));
		
		inbuf=buffer2;
		outbuf=buffer3;
		
		insize=readAllByte(inbuf, innum, eflag);
		sum+=insize;
		outsize=insize;
		
		cd=iconv_open("SJIS","UTF-16BE");
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		//printf("res3=%d\n",res);
		iconv_close(cd);
		if(res==(size_t)(-1)){(*eflag)=12;return;}
		
		result=(char*)Calloc((size_t) ((outbuf-buffer3)+1)*sizeof(char), char);
		flag=1;
		
		for(i=0;i<outbuf-buffer3;i++){
			result[i+(*resultNum)]=buffer3[i];
		}
		
		*resultNum+=outbuf-buffer3;
		
		(*resultString)=result;

		//result[(*resultNum)]='\0';
	}
}

void getList(char** requestString1, char** requestString2, int* requestLength, char** resultString, int* eflag){
	
	char* inbuf;
	int insize;
	int outsize;
	char* buffer5;
	char* outbuf;
	int len;
	iconv_t cd;
	size_t res;
	char buffer;
	char* requestString;
	char numberString[10];
	int numberStrlen, requestStrlen1, requestStrlen2;
	int inputLength;
	
	requestStrlen1 = strlen(*requestString1);
	requestStrlen2 = strlen(*requestString2);
	insize = requestStrlen1 + requestStrlen2;
	
	if(flag2==1){
		Free(results);
	}
	
	//printf("%s\n",(*requestString1));
	//printf("%d\n",(*requestLength));
	results=(char**)Calloc((size_t) (*requestLength)+1, char*);
	
	for(len=0; len<(*requestLength); len++){
		/*---------make request--------*/
		insize = requestStrlen1 + requestStrlen2;
		numberStrlen = sprintf(numberString, "%d", len);
		insize += numberStrlen;
		if((requestString =(char *)R_alloc((long) (insize + 1), sizeof(char)))==NULL){
			(*eflag) = 100;
			//printf("1");
			return ;
		}
		inputLength = sprintf(requestString, "%s", (*requestString1));
		inputLength += sprintf(requestString + inputLength, "%s", numberString);
		inputLength += sprintf(requestString + inputLength, "%s", (*requestString2));
		inbuf = requestString;
		//printf("\n\n\n%s\n inputLength=%d\n", inbuf, inputLength);
		//printf("requset=%d\n insize=%d\n\n", strlen(requestString), insize);
		
		outsize = insize*2+2;
		buffer5=(char *)R_alloc((long) outsize+2, sizeof(char));
		outbuf = buffer5;
		/*-------sendString----------*/
		
		cd=iconv_open("UTF-16BE","SJIS");
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		iconv_close(cd);
		
		//printf("res=%d\n",res);
		
		if(res==(size_t)(-1)){(*eflag)=211;return;}
		
		if(send(sock,buffer5,outbuf-buffer5,0)<0){(*eflag)=221;return;}
		
		/*-------getString----------*/
		
		if(readTwoByte(&buffer,eflag)<0){
			(*eflag)+=230;
			return;
		}
		/*-----1------*/
		if(buffer=='1'){
			//return 1;
		}else if(buffer=='0' || buffer=='2'){
			int i;
			int innum;
			
			int sum=0;
			
			char* buffer3;
			char* buffer2;
			
			/*--------ʸڤФ------------*/
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=240;
				return;
			}
			innum=0;char2int(buffer);
			while(buffer!='\n'){
				innum=innum*10+char2int(buffer);
				if(readTwoByte(&buffer, eflag)<0){
					(*eflag)+=250;
					return;
				}
			}
			if(innum==0){return;}
			
			buffer3=(char *)R_alloc((long) innum, sizeof(char));
			buffer2=(char *)R_alloc((long) innum, sizeof(char));
			
			inbuf=buffer2;
			outbuf=buffer3;
			
			insize=readAllByte(inbuf, innum, eflag);
			sum+=insize;
			outsize=insize;
			
			cd=iconv_open("SJIS","UTF-16BE");
			res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
			//printf("res3=%d\n",res);
			iconv_close(cd);
			if(res==(size_t)(-1)){(*eflag)=12;return;}
			
			results[len]=(char*)Calloc((size_t) ((outbuf-buffer3)+1)*sizeof(char), char);
			
			
			for(i=0;i<outbuf-buffer3;i++){
				results[len][i]=buffer3[i];
			}
			
			//resultNum=outbuf-buffer3;
			
			resultString[len]=results[len];

			resultString[len][(outbuf-buffer3)]='\0';
			
			//Free(buffer2);
			//Free(buffer3);
			//Free(buffer5);
		}
	}
	flag2=1;
}







void getList2(char** requestString1, char** requestString2, int* requestVector, int* requestLength, char** resultString, int* eflag){
	
	char* inbuf;
	int insize;
	int outsize;
	char* buffer5;
	char* outbuf;
	int len;
	iconv_t cd;
	size_t res;
	char buffer;
	char* requestString;
	char numberString[10];
	int numberStrlen, requestStrlen1, requestStrlen2;
	int inputLength;
	
	requestStrlen1 = strlen(*requestString1);
	requestStrlen2 = strlen(*requestString2);
	insize = requestStrlen1 + requestStrlen2;
	
	if(flag2==1){
		Free(results);
	}
	
	//printf("%s\n",(*requestString1));
	//printf("%d\n",(*requestLength));
	results=(char**)Calloc((size_t) (*requestLength)+1, char*);
	
	for(len=0; len<(*requestLength); len++){
		/*---------make request--------*/
		insize = requestStrlen1 + requestStrlen2;
		numberStrlen = sprintf(numberString, "%d", requestVector[len]);
		insize += numberStrlen;
		if((requestString =(char *)R_alloc((long) (insize + 1), sizeof(char)))==NULL){
			(*eflag) = 100;
			//printf("1");
			return ;
		}
		inputLength = sprintf(requestString, "%s", (*requestString1));
		inputLength += sprintf(requestString + inputLength, "%s", numberString);
		inputLength += sprintf(requestString + inputLength, "%s", (*requestString2));
		inbuf = requestString;
		//printf("\n\n\n%s\n inputLength=%d\n", inbuf, inputLength);
		//printf("requset=%d\n insize=%d\n\n", strlen(requestString), insize);
		
		outsize = insize*2+2;
		buffer5=(char *)R_alloc((long) outsize+2, sizeof(char));
		outbuf = buffer5;
		/*-------sendString----------*/
		
		cd=iconv_open("UTF-16BE","SJIS");
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		iconv_close(cd);
		
		//printf("res=%d\n",res);
		
		if(res==(size_t)(-1)){(*eflag)=211;return;}
		
		if(send(sock,buffer5,outbuf-buffer5,0)<0){(*eflag)=221;return;}
		
		/*-------getString----------*/
		
		if(readTwoByte(&buffer,eflag)<0){
			(*eflag)+=230;
			return;
		}
		/*-----1------*/
		if(buffer=='1'){
			//return 1;
		}else if(buffer=='0' || buffer=='2'){
			int i;
			int innum;
			
			int sum=0;
			
			char* buffer3;
			char* buffer2;
			
			/*--------ʸڤEФ------------*/
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=240;
				return;
			}
			innum=0;char2int(buffer);
			while(buffer!='\n'){
				innum=innum*10+char2int(buffer);
				if(readTwoByte(&buffer, eflag)<0){
					(*eflag)+=250;
					return;
				}
			}
			if(innum==0){return;}
			
			buffer3=(char *)R_alloc((long) innum, sizeof(char));
			buffer2=(char *)R_alloc((long) innum, sizeof(char));
			
			inbuf=buffer2;
			outbuf=buffer3;
			
			insize=readAllByte(inbuf, innum, eflag);
			sum+=insize;
			outsize=insize;
			
			cd=iconv_open("SJIS","UTF-16BE");
			res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
			//printf("res3=%d\n",res);
			iconv_close(cd);
			if(res==(size_t)(-1)){(*eflag)=12;return;}
			
			results[len]=(char*)Calloc((size_t) ((outbuf-buffer3)+1)*sizeof(char), char);
			
			
			for(i=0;i<outbuf-buffer3;i++){
				results[len][i]=buffer3[i];
			}
			
			//resultNum=outbuf-buffer3;
			
			resultString[len]=results[len];

			resultString[len][(outbuf-buffer3)]='\0';
			
			//Free(buffer2);
			//Free(buffer3);
			//Free(buffer5);
		}
	}
	flag2=1;
}









void createConnection(char** address, int* eflag){
	
	char buffer;
	struct sockaddr_in addr;
	
#ifdef WIN32
	WSADATA wsadata;
	WORD wversion = MAKEWORD( 2, 0);
	int nError;
	
	//Winsock
	nError = WSAStartup( wversion, &wsadata);
	if( nError) {
		(*eflag)=111;
		return ;
	}
	//WinsockΥСǧ
	if( wversion != wsadata.wVersion) {
		(*eflag)=112;
		return ;
	}
#endif


	
	sock = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	flag=0;
	flag2=0;
	
	if(sock < 0){
		(*eflag)=113;
		return ;
	}
	
	addr.sin_family = AF_INET;
	/* SET IPADDRESS */
	addr.sin_addr.s_addr = inet_addr(*address);
	
	/* SET PORT NUMBER */
	//addr.sin_port = htons(80);
	addr.sin_port = htons(11009);
	
	/* Build Connection with DandDServer */
	if(connect(sock,(struct sockaddr*)&addr,sizeof(addr))<0){
		(*eflag)=114;
		return ;
	}
	/* Catch a flag of beginning of Connection */
	if(readTwoByte(&buffer, eflag)<0){
		return;
	}

	if(buffer!='1'){
		(*eflag)=115;
		return ;
	}
}

int readTwoByte(char* buffer, int* eflag){
	char buffer1[20],buffer2[10];
	char* inbuf=buffer1;
	char* outbuf=buffer2;
	int insize,outsize;
	iconv_t cd;
	size_t res;

	//insize=readAllByte(inbuf,2,eflag);
	insize=recv(sock,inbuf,2,0);
	if(insize<0){
		(*eflag)=2;
		return -1;
	}
	//printf("insize%d\n",insize);
	outsize=insize;

	cd=iconv_open("SJIS","UTF-16BE");
	res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
	if(res<0){(*eflag)=1;return -1;}
	iconv_close(cd);
	(*buffer)=buffer2[0];
	//printf("ge=%c\n",buffer2[0]);
	return 0;
}

int char2int(char inbuf){
	inbuf&=0x0f;
	return (int)inbuf;
}

int readAllByte(char* inbuf, int readsize, int* eflag){
	int insize=0;
	int recvSize=0;
	char* posi=inbuf;
	while(insize<readsize){
		recvSize=recv(sock,posi+insize,readsize-insize,0);
		insize+=recvSize;
		//printf("%d",recvSize);
		if(recvSize<0){
			(*eflag)=2;
			return -1;
		}
	}
	inbuf[insize]='\0';
	return insize;
}

void closeConnection(int* eflag){

#ifdef WIN32
	if(closesocket(sock)<0){
		(*eflag)=3;
	}
	WSACleanup();
#else
	if(close(sock)<0){
		(*eflag)=3;
	}
#endif
	return ;
}

void stringMatch(char** longNames, int* length, int* eflag)
{
	int i,j;
	int num = strlen(longNames[0]);
	if(num<0){(*eflag)=-1;return;}
	
	for(i=1;i<(*length);i++){
		if(num > strlen(longNames[i])){
			num = strlen(longNames[i]);
		}
	}
	for(j=0;j<(*length);j++){
		for(i=0;i<num;i++){
			if(longNames[0][i] != longNames[j][i]){
				//printf("%d", i);
				longNames[0][i]='\0';
				num=i;
				break;
			}
		}
	}
	//printf("%s\n", longNames[0]);
}

void normalString(char** longNames, int* length, int* eflag){
	int i, j, k, stringLength;
	char* buffer;
	
	for(i=0; i<(*length); i++){
		k = 0;
		stringLength = strlen(longNames[i]);
		if(stringLength > 0){
			buffer = (char *)R_alloc((long) stringLength, sizeof(char));
			for(j=0;j<stringLength;j++){
				if((longNames[i][j] >= '0' && longNames[i][j] <= '9') || (longNames[i][j] >= 'A' && longNames[i][j] <= 'Z') || (longNames[i][j] >= 'a' && longNames[i][j] <= 'z')){
					buffer[k] = longNames[i][j];
					k++;
				}
			}
			buffer[k] = '\0';
			sprintf(longNames[i], "%s", buffer);
		}
	}
	return;
}

void getInstance(char** requestString, int* requestNum, char** fileName, int* resultNum, int* eflag){
	
	FILE *fp;
	char* inbuf=*requestString;
	int insize=*requestNum;
	int outsize=2*insize;
	char* buffer5=(char *)R_alloc((long) outsize, sizeof(char));
	char* outbuf=buffer5;
	iconv_t cd;
	size_t res;
	char buffer;




	//printf("flag=%d\n",flag);
	if(flag==1){
		Free(result);
	}
	

	

	
	/*-------sendString----------*/
	
	cd=iconv_open("UTF-16BE","SJIS");
	res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
	iconv_close(cd);
	
	//printf("res=%d\n",res);
	
	if(res==(size_t)(-1)){(*eflag)=211;return;}
	
	if(send(sock,buffer5,outbuf-buffer5,0)<0){(*eflag)=221;return;}
	
	/*-------getString----------*/
	

	if(readTwoByte(&buffer,eflag)<0){
		(*eflag)+=230;
		return;
	}
	/*-----1E֤Eͤʤ)------*/
	if(buffer=='1'){
		//return 1;
	}else if(buffer=='0' || buffer=='2'){
		int i, j = 0, tagNumber = 0;
		int innum;
		
		char* buffer2;
		char* buffer3;
		char* buffer4;
		
		/*--------ʸڤEФ------------*/
		if(readTwoByte(&buffer, eflag)<0){
			(*eflag)+=240;
			return;
		}
		innum=0;char2int(buffer);
		while(buffer!='\n'){
			innum=innum*10+char2int(buffer);
			if(readTwoByte(&buffer, eflag)<0){
				(*eflag)+=250;
				return;
			}
		}
		if(innum==0){return;}
		
		buffer3=(char *)R_alloc((long) innum, sizeof(char));
		buffer2=(char *)R_alloc((long) innum, sizeof(char));
		
		
		inbuf=buffer2;
		outbuf=buffer3;
		
		insize=readAllByte(inbuf, innum, eflag);
		printf("insize=%d\n",insize);
		printf("innum=%d\n",innum);
		outsize=insize;
		
		if((cd=iconv_open("EUC-JP","UTF-16BE")) < 0){(*eflag)=13;return;}
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		//printf("res3=%d\n",res);
		iconv_close(cd);
		//if(res==(size_t)(-1)){(*eflag)=12;return;}
		
		result=(char*)Calloc((size_t) ((outbuf-buffer3)*2)*sizeof(char), char);
		flag=1;
		
		if((fp = fopen(*fileName, "w")) < 0){
			printf("file cannot open!");
		}
		
		fwrite(buffer3, outbuf -  buffer3, 1, fp);
		
		/*for(i=0;i<outbuf-buffer3;i++){
			if(buffer3[i] == '>'){
				result[j]=buffer3[i];
				//result[j+1] = '\r';
				result[j+2] = '\n';
				j += 2;
				tagNumber++;
			}else{
				result[j]=buffer3[i];
			}
			j++;
		}
		result[j] = '\0';
		
		buffer4=(char *)R_alloc((long) j, sizeof(char));
		
		inbuf = result;
		outbuf = buffer4;
		
		insize = j;
		outsize = j*2;
		
		if((cd=iconv_open("UTF-16", "SJIS")) < 0){(*eflag)=13;return;}
		res=iconv(cd,(const char**)&inbuf,&insize,&outbuf,&outsize);
		printf("res3=%d\n",res);
		iconv_close(cd);
		
		fwrite(buffer4, outbuf - buffer4, 1, fp);
		fprintf(fp, buffer4);*/
		fclose(fp);
	}
}
