DandDoptions=function(...){
	Server = list(...)$Ser
	Language = list(...)$L
	SearchList = list(...)$Sea
	if(exists(".DandDOptions",1,inherits = FALSE)){
		DandDOptions = .DandDOptions
	}else{
		DandDOptions = list(Server="131.113.65.15", 
		Language=if (0) {
			    "Japanese"
			}
			else {
			    "English"
			},
			SearchList=c(
			bs2s(getwd()),
			if (0) {
			    bs2s(paste(c(Sys.getenv(c("HOMEDRIVE", "HOMEPATH")),"\\fXNgbv\\"), collapse = ""))
			}
			else {
			    bs2s(paste(c(Sys.getenv(c("HOMEDRIVE", "HOMEPATH")),"/Desktop/"), collapse = ""))
			},
			"http://www.stat.math.keio.ac.jp/DandDIV/Examples/")
			)
		assign(".DandDOptions",DandDOptions, 1)
	}
	if(!is.null(Server)){
		DandDOptions$Server = Server
	}
	if(!is.null(Language)){
		DandDOptions$Language = Language
	}
	if(!is.null(SearchList)){
		SearchList = unlist(lapply(as.list(SearchList), bs2s))
		SearchList = unique(SearchList)
		DandDOptions$SearchList = SearchList
	}
	assign(".DandDOptions",DandDOptions, 1)
	DandDOptions
}
