"Split" <-
function (vector = c(NA, 0, 3, -5, 1, 6, 1, 1, 3)) 
{
    Data = unique(vector)
    if (length(Data) <= 7) {
        X = sort(Data)
        Y = rep(NA, length = length(vector))
        for (i in seq(vector)) Y[i] = match(vector[i], X)
    }
    else {
        Range = range(vector[!is.na(vector)])
        X = seq(Range[1], Range[2], length = 8)
        Y = rep(NA, length = length(vector))
        for (i in 1:7) {
            if (i != 7) 
                Y[vector >= X[i] & vector < X[i + 1]] = i
            else Y[vector > X[i] & vector <= X[i + 1]] = i
        }
    }
    return(Y, X)
}
