"attachDandD" <-
function (dad, override = T) 
{
	if(missing(dad)){
		SearchList = DandDoptions()$SearchList
		lapply(as.list(rev(SearchList)), attachDandD)
		SearchList
	}
	else if(class(dad)=="dad"){
    if(as.numeric(R.Version()$minor)<1){
			environ = list()
	    for (i in 1:length(dad)) {
	        Dname = paste(attr(dad, "name"), names(dad[i]), sep = ":")
	        pos = match(Dname, search(), 0)
	        if (pos) {
	            if (override) {
                detach(pos = pos)
              }
              else {
                return(dad)
              } 
	        }
	        Env = attach(list(), name = Dname)
	        for (j in 1:length(dad[[i]])) {
	            assign(names(dad[[i]][j]), do.call("delay", list(call("eval", 
	                dad[[i]][[j]]))), env = Env)
	        }
	        environ[[i]] = Env
	        attr(dad[[i]], "Environment") = Env
	    }
	    return(invisible(dad))
		}else{
    dadAttr = attributes(dad)
    dadName = attr(dad, "name")
    dad = lapply(dad, function(relation, override){
        Dname = paste(dadName, attr(relation, "ShortName"), sep = ":")
        pos = match(Dname, search(), 0)
        if (pos) {
            if (override) {
                detach(pos = pos)
            }
            else {
                return(dad)
            }
        }
        Env = attach(list(), name = Dname)
        lapply(as.list(names(relation)), function(xx, structure, Env) {
            delayedAssign(xx, eval(structure[[xx]]),assign= Env)
        }, relation, Env)
        attr(relation, "Environment") = Env
        relation
    }, override)
    attributes(dad) = dadAttr
    return(invisible(dad))
    }
  }else{
		if(length(grep("/$", dad))==0 & length(grep("/", dad))>0){
			dad = paste(dad,"/",sep="")
		}
		if(length(grep("\\\\$", dad))==0 & length(grep("\\\\", dad))>0){
			dad = paste(dad,"\\",sep="")
		}
		dad = gsub("\\\\","/",dad)
		#dad = gsub(" ","\\\\ ",dad)
		#print(dad)
		pos = match("DandDInstances", search(), 0)
		if (pos){
			if (override) {
          #detach(pos = pos)
          Env = as.environment(pos)
      } else {
				  cat("The environment is already attached.\n")
          return
      }
    } else {
			Env = attach(list(), name = "DandDInstances")
		}
		if (length(grep("http", dad))) {
        Dname=dad
        files = instanceNames = c("Iris.dad", "NewSwimMen200Fr.dad", "Housing.dad", "Compe2003.dad", 
        "AcidRain.dad", "Futures2002_2003.dad", "Marketing.dad", "BreathHeart.dad", "Gas_estima.dad", 
        "TOPIX1991_2002.dad", "Kyphosis.dad", "ProtoAyu.dad", "Solder.dad", "Car.dad", "ATandT.dad")
        if(length(files)>0){
					#Env = attach(list(), name = Dname)
					if(as.numeric(R.Version()$minor)<1){
						for (j in 1:length(files)) {
	            assign(files[j], do.call("delay", list(call("DandD", files[j], Dname))), env = Env)
	        	}
					}else{
						lapply(as.list(files), function(xx, Dname, Env) {
	            delayedAssign(xx, DandD(xx, prefix=Dname),assign= Env)
	          }, Dname, Env)
          }
          return(invisible(Env))
				}
    } else {
        Dname=dad
        files = list.files(Dname, pattern=".dad$")
        if(length(files)>0){
					#Env = attach(list(), name = Dname)
					#Env = as.environment(pos)
					if(as.numeric(R.Version()$minor)<1){
						for (j in 1:length(files)) {
	            assign(files[j], do.call("delay", list(call("DandD", files[j], Dname))), env = Env)
	        	}
					}else{
						lapply(as.list(files), function(xx, Dname, Env) {
	            delayedAssign(xx, DandD(xx, prefix=Dname),assign= Env)
	          }, Dname, Env)
	        }
          return(invisible(Env))
				}
    }
	}
}

