makeButton=function (xlim, ylim, bcol, bcol2, bcol3, btext2, visible, visible2, 
    visible3, piece, scaling, visible.clus) 
{
    cex.menu = 0.8
    temp1 = 0.03 * diff(ylim)
    temp2 = c(1:4) * 0.13 * diff(xlim)
    temp3 = c(1:6) * 0.13 * diff(xlim)
    rect(xlim[1] + temp2[3], ylim[2], xlim[1] + temp2[4], ylim[2] - 
        temp1, col = "#999999", border = 0)
    text(xlim[1] + temp2[3] + temp2[1]/2, ylim[2] - temp1/2, 
        "Clear", col = "white", cex = cex.menu)
    rect(c(xlim[1], xlim[1] + temp2, xlim[2] - temp2[1]), rep(ylim[2], 
        6), c(xlim[1] + temp3[1:4], xlim[2] - temp2[1], xlim[2]), 
        rep(ylim[2] + temp1, 6), col = c(bcol[1], rep("black", 
            6)), border = 0)
    text(c(c(xlim[1] + temp3[1:5]) - temp2[1]/2, xlim[1]+temp3[5]+temp3[1]/4, xlim[1]+temp3[5]+temp3[1]/4*3), ylim[2] + temp1/2, 
        c("Zoom in", "Zoom out", "Undo", "Redo", "Initialise", "+","-"), 
        cex = cex.menu, col = "white")
    text(xlim[2], ylim[2] + temp1/2, "Quit ", pos = 2, col = "white", 
        cex = cex.menu)
    rect(c(xlim[1], xlim[1] + temp2[1:2]), rep(ylim[2], 3), xlim[1] + 
        temp2[1:3], rep(ylim[2] - temp1, 3), col = bcol[5:7], 
        border = 0)
    text(xlim[1] + temp2[1:3] - temp2[1]/2, ylim[2] - temp1/2, 
        c("Warp", "Weft", "Point"), cex = cex.menu, col = "white")
    if (visible) {
        rect(c(xlim[1], xlim[1] + temp3[1:4]), rep(ylim[2] - 
            temp1 * 2, 2), xlim[1] + temp3[1:5], rep(ylim[2] - 
            temp1 * 1, 2), col = bcol3, border = 0)
        text(xlim[1] + temp3[1:5] - temp2[1]/2, ylim[2] - temp1 - 
            temp1/2, c("New", "Union", "Intersect", "Diff", "Toggle"), 
            cex = cex.menu, col = "white")
        if (visible2) {
            rect(c(xlim[1], xlim[1] + temp2[1]), rep(ylim[2] - 
                temp1 * 3, 2), xlim[1] + temp2[1:2], rep(ylim[2] - 
                temp1 * 2, 2), col = bcol[8:9], border = 0)
            text(xlim[1] + temp2[1:2] - temp2[1]/2, ylim[2] - 
                temp1 * 2 - temp1/2, c("Adopt", "Drop"), cex = cex.menu, 
                col = "white")
        }
        if (visible3) {
            rect(xlim[1] + temp2[2], ylim[2] - temp1 * 3, xlim[1] + 
                temp2[3], ylim[2] - temp1 * 2, col = bcol[10], 
                border = 0)
            text(xlim[1] + temp2[3] - temp2[1]/2, ylim[2] - temp1 * 
                2 - temp1/2, "Move", cex = cex.menu, col = "white")
            rect(xlim[1] + temp2[3], ylim[2] - temp1 * 3, xlim[1] + 
                temp2[4], ylim[2] - temp1 * 2, col = "#999999", 
                border = 0)
            text(xlim[1] + temp2[4] - temp2[1]/2, ylim[2] - temp1 * 
                2 - temp1/2, "Transform", cex = cex.menu, col = "white")
        }
    }
    if(visible.clus){
			rect(xlim[1] + temp2[3], ylim[1], xlim[1] + temp2[4], ylim[1] + temp1 * 8, col = "#999999", border = 0)
			text(xlim[1] + temp2[4] - temp2[1]/2, ylim[1]+cumsum(rep(temp1, 8))-temp1/2, c("ward", "single",
          "complete", "average", "mcquitty", "median", "centroid", "kumasaka"), col="white", cex=cex.menu)
		}
    rect(c(xlim[1], xlim[1] + temp3), rep(ylim[1] - temp1, 7), 
        c(xlim[1] + temp3, xlim[2]), rep(ylim[1], 7), col = c(bcol2, 
            "black"), border = 0)
    text(xlim[1] + temp3 - temp2[1]/2, ylim[1] - temp1/2, btext2, 
        cex = cex.menu, col = "white")
    if (scaling) {
        rect(xlim[1] + temp3[1] * 6, ylim[1], xlim[1] + temp3[1] * 
            7, ylim[1] - temp1, col = "#669999", border = 0)
    }
    text(xlim[1] + temp2[1] * 13/2, ylim[1] - temp1/2, "Scaling", 
        cex = cex.menu, col = "white")
    text(xlim[2], ylim[1] - temp1/2, paste("Piece=", piece, sep = ""), 
        cex = cex.menu, col = "white", pos = 2)
}
