"radix" <-
function (dad) 
{
    getString(paste("doc=loadDocument(\"", attr(dad, "where"), 
        "\")", sep = ""))
    getString("titleList=doc.getElementsByTagName(\"Title\")")
    languageString = getString("titleList.item(0).getAttribute(\"Language\")")
    lang = unlist(strsplit(languageString, " "))
    langNum = seq(lang)[lang == attr(dad, "Language")]
    appNodeName = NULL
    appLongName = NULL
    appId = NULL
    appNumList = NULL
    Systems = NULL
    getString("timeSystemsList=doc.getElementsByTagName(\"Time\")")
    timeSystemsNumber = as.numeric(getString("timeSystemsList.getLength()"))
    if (timeSystemsNumber) {
        for (i in 0:(timeSystemsNumber - 1)) {
            appNodeName = c(appNodeName, getString(paste("timeSystemsList.item(", 
                i, ").getNodeName()", sep = "")))
            appIdString = getString(paste("timeSystemsList.item(", 
                i, ").getAttribute(\"Id\")", sep = ""))
            appId = c(appId, appIdString)
            appLongNameString = getString(paste("timeSystemsList.item(", 
                i, ").getAttribute(\"LongName\")", sep = ""))
            appLongNameString = unlist(strsplit(appLongNameString, 
                " "))[langNum]
            appLongName = c(appLongName, getString(paste("getValue(doc.getElementById(\"", 
                appLongNameString, "\"))", sep = "")))
            getString(paste("radixChildList=timeSystemsList.item(", 
                i, ").getChildNodes()", sep = ""))
            radixNodeNum = as.numeric(getString("radixChildList.getLength()"))
            radixName = NULL
            radixRefId = NULL
            for (j in 0:(radixNodeNum - 1)) {
                radixNodeName = getString(paste("radixChildList.item(", 
                  j, ").getNodeName()", sep = ""))
                if (radixNodeName != "#text") {
                  radixName = c(radixName, radixNodeName)
                  radixRefId = c(radixRefId, getString(paste("radixChildList.item(", 
                    j, ").getAttribute(\"RefId\")", sep = "")))
                }
            }
            Systems[[appIdString]] = data.frame(NodeName = radixName, 
                RefId = radixRefId)
        }
    }
    getString("longiLatiSystemsList=doc.getElementsByTagName(\"LongitudeLatitude\")")
    longiLatiSystemsNumber = as.numeric(getString("longiLatiSystemsList.getLength()"))
    if (longiLatiSystemsNumber) {
        for (i in 0:(longiLatiSystemsNumber - 1)) {
            appNodeName = c(appNodeName, getString(paste("longiLatiSystemsList.item(", 
                i, ").getNodeName()", sep = "")))
            appIdString = getString(paste("longiLatiSystemsList.item(", 
                i, ").getAttribute(\"Id\")", sep = ""))
            appId = c(appId, appIdString)
            appLongNameString = getString(paste("longiLatiSystemsList.item(", 
                i, ").getAttribute(\"LongName\")", sep = ""))
            appLongNameString = unlist(strsplit(appLongNameString, 
                " "))[langNum]
            appLongName = c(appLongName, getString(paste("getValue(doc.getElementById(\"", 
                appLongNameString, "\"))", sep = "")))
            getString(paste("radixChildList=longiLatiSystemsList.item(", 
                i, ").getChildNodes()", sep = ""))
            radixNodeNum = as.numeric(getString("radixChildList.getLength()"))
            radixName = NULL
            radixRefId = NULL
            for (j in 0:(radixNodeNum - 1)) {
                radixNodeName = getString(paste("radixChildList.item(", 
                  j, ").getNodeName()", sep = ""))
                if (radixNodeName != "#text") {
                  radixName = c(radixName, radixNodeName)
                  radixRefId = c(radixRefId, getString(paste("radixChildList.item(", 
                    j, ").getAttribute(\"RefId\")", sep = "")))
                }
            }
            Systems[[appIdString]] = data.frame(NodeName = radixName, 
                RefId = radixRefId)
        }
    }
    getString("sexaSystemsList=doc.getElementsByTagName(\"Sexagesimal\")")
    sexaSystemsNumber = as.numeric(getString("sexaSystemsList.getLength()"))
    if (sexaSystemsNumber) {
        for (i in 0:(sexaSystemsNumber - 1)) {
            appNodeName = c(appNodeName, getString(paste("sexaSystemsList.item(", 
                i, ").getNodeName()", sep = "")))
            appIdString = getString(paste("sexaSystemsList.item(", 
                i, ").getAttribute(\"Id\")", sep = ""))
            appId = c(appId, appIdString)
            appLongNameString = getString(paste("sexaSystemsList.item(", 
                i, ").getAttribute(\"LongName\")", sep = ""))
            appLongNameString = unlist(strsplit(appLongNameString, 
                " "))[langNum]
            appLongName = c(appLongName, getString(paste("getValue(doc.getElementById(\"", 
                appLongNameString, "\"))", sep = "")))
            getString(paste("radixChildList=sexaSystemsList.item(", 
                i, ").getChildNodes()", sep = ""))
            radixNodeNum = as.numeric(getString("radixChildList.getLength()"))
            radixName = NULL
            radixRefId = NULL
            for (j in 0:(radixNodeNum - 1)) {
                radixNodeName = getString(paste("radixChildList.item(", 
                  j, ").getNodeName()", sep = ""))
                if (radixNodeName != "#text") {
                  radixName = c(radixName, radixNodeName)
                  radixRefId = c(radixRefId, getString(paste("radixChildList.item(", 
                    j, ").getAttribute(\"RefId\")", sep = "")))
                }
            }
            Systems[[appIdString]] = data.frame(NodeName = radixName, 
                RefId = radixRefId)
        }
    }
    getString("keysSystemsList=doc.getElementsByTagName(\"Keys\")")
    keysSystemsNumber = as.numeric(getString("keysSystemsList.getLength()"))
    if (keysSystemsNumber) {
        for (i in 0:(keysSystemsNumber - 1)) {
            appNodeName = c(appNodeName, getString(paste("keysSystemsList.item(", 
                i, ").getNodeName()", sep = "")))
            appIdString = getString(paste("keysSystemsList.item(", 
                i, ").getAttribute(\"Id\")", sep = ""))
            appId = c(appId, appIdString)
            appLongNameString = getString(paste("keysSystemsList.item(", 
                i, ").getAttribute(\"LongName\")", sep = ""))
            appLongNameString = unlist(strsplit(appLongNameString, 
                " "))[langNum]
            appLongName = c(appLongName, getString(paste("getValue(doc.getElementById(\"", 
                appLongNameString, "\"))", sep = "")))
            getString(paste("radixChildList=keysSystemsList.item(", 
                i, ").getChildNodes()", sep = ""))
            radixNodeNum = as.numeric(getString("radixChildList.getLength()"))
            radixName = NULL
            radixRefId = NULL
            for (j in 0:(radixNodeNum - 1)) {
                radixNodeName = getString(paste("radixChildList.item(", 
                  j, ").getNodeName()", sep = ""))
                if (radixNodeName != "#text") {
                  radixName = c(radixName, radixNodeName)
                  radixRefId = c(radixRefId, getString(paste("radixChildList.item(", 
                    j, ").getAttribute(\"RefId\")", sep = "")))
                }
            }
            Systems[[appIdString]] = data.frame(NodeName = radixName, 
                RefId = radixRefId)
        }
    }
    getString("longitudinalSystemsList=doc.getElementsByTagName(\"Longitudinal\")")
    longitudinalSystemsNumber = as.numeric(getString("longitudinalSystemsList.getLength()"))
    if (longitudinalSystemsNumber) {
        for (i in 0:(longitudinalSystemsNumber - 1)) {
            appNodeName = c(appNodeName, getString(paste("longitudinalSystemsList.item(", 
                i, ").getNodeName()", sep = "")))
            appIdString = getString(paste("longitudinalSystemsList.item(", 
                i, ").getAttribute(\"Id\")", sep = ""))
            appId = c(appId, appIdString)
            appLongNameString = getString(paste("longitudinalSystemsList.item(", 
                i, ").getAttribute(\"LongName\")", sep = ""))
            appLongNameString = unlist(strsplit(appLongNameString, 
                " "))[langNum]
            appLongName = c(appLongName, getString(paste("getValue(doc.getElementById(\"", 
                appLongNameString, "\"))", sep = "")))
            getString(paste("radixChildList=longitudinalSystemsList.item(", 
                i, ").getChildNodes()", sep = ""))
            radixNodeNum = as.numeric(getString("radixChildList.getLength()"))
            radixName = NULL
            radixRefId = NULL
            for (j in 0:(radixNodeNum - 1)) {
                radixNodeName = getString(paste("radixChildList.item(", 
                  j, ").getNodeName()", sep = ""))
                if (radixNodeName != "#text") {
                  radixName = c(radixName, radixNodeName)
                  radixRefId = c(radixRefId, getString(paste("radixChildList.item(", 
                    j, ").getAttribute(\"RefId\")", sep = "")))
                }
            }
            Systems[[appIdString]] = data.frame(NodeName = radixName, 
                RefId = radixRefId)
        }
    }
    RadixId = NULL
    if (length(appId)) {
        RadixId = data.frame(NodeName = appNodeName, Id = appId, 
            LongName = appLongName, Number = c(1:length(appId)))
    }
    if (length(RadixId) == 0) {
        return(dad)
    }
    if (length(Systems) == 0) {
        return(dad)
    }
    TimeRadixId = as.character(RadixId[RadixId$NodeName == "Time", 
        ]$Id)
    if (length(TimeRadixId) > 0) {
        for (i in 1:length(TimeRadixId)) {
            Radix = Systems[[TimeRadixId[i]]]
            SecRefId = as.character(Radix[match(c("Hour", "Minute", 
                "Second"), Radix$NodeName), ]$RefId)
            if (length(SecRefId) > 0) {
                RefId = TimeRadixId[i]
                LongName = as.character(RadixId[RadixId$Id == 
                  TimeRadixId[i], ]$LongName)
                for (j in 1:length(dad)) {
                  SecNum = match(SecRefId, lapply(dad[[j]], attr, 
                    "Id"))
                  if (length(unlist(dad[[j]][SecNum])) > 0) {
                    Temp = call("makeSeconds", dad[[j]][[SecNum[1]]], 
                      dad[[j]][[SecNum[2]]], dad[[j]][[SecNum[3]]])
                    dataVectorType = attr(dad[[j]][SecNum][[1]], 
                      "DataVectorType")
                    dataType = attr(dad[[j]][SecNum][[1]], "DataType")
					SystemsId = attr(dad[[j]][SecNum][[1]], "Systems")
                    dad[[j]][SecNum] = NULL
                    Names = abbreviate(normal(c(LongName, unlist(lapply(dad[[j]], 
                      attr, "Names")))), minlength = 7)[1]
                    dad[[j]][[Names]] = Temp
                    attr(dad[[j]][[Names]], "LongName") = LongName
                    attr(dad[[j]][[Names]], "Names") = Names
                    attr(dad[[j]][[Names]], "Id") = RefId
                    attr(dad[[j]][[Names]], "Unit") = "Seconds"
                    attr(dad[[j]][[Names]], "DataType") = dataType
                    attr(dad[[j]][[Names]], "DataVectorType") = dataVectorType
					attr(dad[[j]][[Names]], "Systems") = SystemsId
                  }
                }
            }
            JulRefId = as.character(Radix[match(c("Year", "Month", 
                "Day"), Radix$NodeName, 0), ]$RefId)
            if (length(JulRefId) == 3) {
                RefId = TimeRadixId[i]
                secRefId = TimeRadixId[i]
                LongName = as.character(RadixId[RadixId$Id == 
                  TimeRadixId[i], ]$LongName)
                for (j in 1:length(dad)) {
                  JulNum = match(JulRefId, lapply(dad[[j]], attr, 
                    "Id"))
                  SecNum = match(secRefId, lapply(dad[[j]], attr, 
                    "Id"), 0)
                  if (length(unlist(dad[[j]][JulNum])) > 0) {
                    dataVectorType = attr(dad[[j]][JulNum][[1]], 
                      "DataVectorType")
                    dataType = attr(dad[[j]][JulNum][[1]], "DataType")
                    SystemsId = attr(dad[[j]][JulNum][[1]], "Systems")
                    if (SecNum) {
                      Temp = call("jul", dad[[j]][[JulNum[1]]], 
                        dad[[j]][[JulNum[2]]], dad[[j]][[JulNum[3]]])
                      Temp2 = call("/", dad[[j]][[SecNum]], 86400)
                      Temp = call("+", Temp, Temp2)
                      dad[[j]][c(SecNum, JulNum)] = NULL
                      Names = abbreviate(normal(c(LongName, unlist(lapply(dad[[j]], 
                        attr, "Names")))), minlength = 7)[1]
                      dad[[j]][[Names]] = Temp
                      attr(dad[[j]][[Names]], "LongName") = LongName
                      attr(dad[[j]][[Names]], "Names") = Names
                      attr(dad[[j]][[Names]], "Id") = RefId
                      attr(dad[[j]][[Names]], "Unit") = "Julian Day"
                      attr(dad[[j]][[Names]], "DataType") = dataType
                      attr(dad[[j]][[Names]], "DataVectorType") = dataVectorType
                      attr(dad[[j]][[Names]], "Systems") = SystemsId
                    }
                    else {
                      Temp = call("jul", dad[[j]][[JulNum[1]]], 
                        dad[[j]][[JulNum[2]]], dad[[j]][[JulNum[3]]])
                      dad[[j]][JulNum] = NULL
                      Names = abbreviate(normal(c(LongName, unlist(lapply(dad[[j]], 
                        attr, "Names")))), minlength = 7)[1]
                      dad[[j]][[Names]] = Temp
                      attr(dad[[j]][[Names]], "LongName") = LongName
                      attr(dad[[j]][[Names]], "Names") = Names
                      attr(dad[[j]][[Names]], "Id") = RefId
                      attr(dad[[j]][[Names]], "Unit") = "Julian Day"
                      attr(dad[[j]][[Names]], "DataType") = dataType
                      attr(dad[[j]][[Names]], "DataVectorType") = dataVectorType
                      attr(dad[[j]][[Names]], "Systems") = SystemsId
                    }
                  }
                }
            }
        }
    }
    SexagesimalRadixId = as.character(RadixId[RadixId$NodeName == 
        "Sexagesimal", ]$Id)
    if (length(SexagesimalRadixId) > 0) {
        for (i in 1:length(SexagesimalRadixId)) {
            Radix = Systems[[SexagesimalRadixId[i]]]
            SexaRefId = as.character(Radix[match(c("Degree", 
                "Minute", "Second"), Radix$NodeName), ]$RefId)
            if (length(SexaRefId) > 0) {
                RefId = SexagesimalRadixId[i]
                LongName = as.character(RadixId[RadixId$Id == 
                  SexagesimalRadixId[i], ]$LongName)
                for (j in 1:length(dad)) {
                  SexaNum = match(SexaRefId, lapply(dad[[j]], 
                    attr, "Id"))
                  if (length(unlist(dad[[j]][SexaNum])) > 0) {
                    Temp = call("makeDegree", dad[[j]][[SexaNum[1]]], 
                      dad[[j]][[SexaNum[2]]], dad[[j]][[SexaNum[3]]])
                    dataVectorType = attr(dad[[j]][SexaNum][[1]], 
                      "DataVectorType")
                    dataType = attr(dad[[j]][SexaNum][[1]], "DataType")
                    SystemsId = attr(dad[[j]][SexaNum][[1]], "Systems")
                    dad[[j]][SexaNum] = NULL
                    Names = abbreviate(normal(c(LongName, unlist(lapply(dad[[j]], 
                      attr, "Names")))), minlength = 7)[1]
                    dad[[j]][[Names]] = Temp
                    attr(dad[[j]][[Names]], "LongName") = LongName
                    attr(dad[[j]][[Names]], "Names") = Names
                    attr(dad[[j]][[Names]], "Id") = RefId
                    attr(dad[[j]][[Names]], "Unit") = "Degree"
                    attr(dad[[j]][[Names]], "DataType") = dataType
                    attr(dad[[j]][[Names]], "DataVectorType") = dataVectorType
                    attr(dad[[j]][[Names]], "Systems") = SystemsId
                  }
                }
            }
        }
    }
    return(dad)
}
