.arrange = "abss"

rearrange=function(x){
	get(.arrange)(x)
}


abss=function (x, method) 
{
    p = dim(x)[2]
    n = dim(x)[1]
    k = ceiling(p/5)
    k = 0
    x.d = apply(x, 2, function(xx) {
        apply(x, 2, function(xxx) {
            sum(abs(xx - xxx), na.rm = T)/sum((!is.na(xx))&(!is.na(xxx)))
        })
    })
    x.d = c(x.d)
    names(x.d) = NULL
    x.d = matrix(c(x.d), p)
    if(method=="kumasaka"){
			Hclust(x.d)
		}else{
    	hclust(as.dist(x.d), method=method)
    }
}



abss2=function (y)
{
    mm = y[, 1]
    x = y[, -1]
    p = dim(x)[2]
    n = dim(x)[1]
    k = ceiling(p/5)
    k = 0

    x.d = apply(x, 2, function(xx) {
        apply(x, 2, function(xxx) {
            sum(abs(xx - xxx),na.rm=T)
            #sum(xx*xxx,na.rm=T)
        })
    })
    x.d=c(x.d)
    names(x.d)=NULL
    x.d=matrix(c(x.d), p)
    result.ord = minDist(x.d)

    result.ord
}


lengths=function(y){
	mm = y[,1]
	x = y[,-1]
	p = dim(x)[2]
	n = dim(x)[1]
	x = apply(x, 2, function(xx){xx[is.na(xx)] = 0; xx})
	x.d=apply(x, 2, function(xx){
		apply(x, 2, function(xxx){
			sum(sqrt(1+(xx-xxx)^2))
		})
	})
	diag(x.d) = Inf
	x.d.temp = x.d
	result = matrix(rep(0, p*(p+1)),p)
	for(i in 1:p){
		x.d = x.d.temp
		result[i,1] = i
		for(j in 2:(p)){
			#print(x.d)
			result[i,p+1] = result[i,p+1]+sort(x.d[result[i,j-1],])[1]
			result[i,j] = order(x.d[result[i,j-1],])[1]
			#x.d[i,]=Inf
			#x.d[j,]=Inf
			x.d[,i]=Inf
			x.d[,result[i,j]]=Inf
		}
		
	}
	result[order(result[,p+1])[1], -(p+1)]
}





squares = function(y){
	mm = y[,1]
	x = y[,-1]
	p = dim(x)[2]
	n = dim(x)[1]
	x = apply(x, 2, function(xx){xx[is.na(xx)] = 0; xx})
	x.d = as.matrix(dist(t(x)))
	diag(x.d) = Inf
	x.d.temp = x.d
	result = matrix(rep(0, p*(p+1)),p)
	for(i in 1:p){
		x.d = x.d.temp
		result[i,1] = i
		for(j in 2:(p)){
			#print(x.d)
			result[i,p+1] = result[i,p+1]+sort(x.d[result[i,j-1],])[1]
			result[i,j] = order(x.d[result[i,j-1],])[1]
			#x.d[i,]=Inf
			#x.d[j,]=Inf
			x.d[,i]=Inf
			x.d[,result[i,j]]=Inf
		}
		
	}
	result[order(result[,p+1])[1], -(p+1)]
}







abss2=function (y) 
{
    mm = y[, 1]
    x = y[, -1]
    p = dim(x)[2]
    n = dim(x)[1]
    k = ceiling(p/5)
    k=0
    x.d = apply(x, 2, function(xx) {
        apply(x, 2, function(xxx) {
            sum(abs(xx - xxx),na.rm=T)
        })
    })
    
    
    diag(x.d) = Inf
    x.d.temp = x.d
    result = matrix(rep(0, p * (p + 1)), p)
    for (i in 1:p) {
        x.d = x.d.temp
        result[i, 1] = i
        for (j in 2:(p)) {
            result[i, p + 1] = result[i, p + 1] + sort(x.d[result[i, j - 1], ])[1]
            result[i, j] = order(x.d[result[i, j - 1], ])[1]
            x.d[, i] = Inf
            x.d[, result[i, j]] = Inf
        }
    }
    result.ord=order(apply(result[,-(p+1)],1,function(ord){sum(sort(
    ifelse(is.null(dim(x[,ord[-1]])),sum(x[,ord[-1]]-x[,ord[-p]],na.rm=1),apply(abs(x[,ord[-1]]-x[,ord[-p]]),2,sum,na.rm=T)))[1:(p-k)])}))
    
    result.ord=minDist(max(result)+1-result)
    
    if(sum(mm*x[,result[order(result.ord)[1], 1]],na.rm=T) > sum(mm*x[,result[order(result.ord)[1], p]],na.rm=T)){
    	result[order(result.ord)[1], -(p + 1)]
    }else{
    	rev(result[order(result.ord)[1], -(p + 1)])
   }
}




areas=function(y){
	mm = y[,1]
	x = y[,-1]
	p = dim(x)[2]
	n = dim(x)[1]
	x = apply(x, 2, function(xx){xx[is.na(xx)] = 0; xx})
	x.d = apply(x-mm, 2, function(xx){
		apply(x-mm, 2, function(xxx){
			temp1=(xx>0&xxx>0)||(xx<0&xxx<0)
			temp2=(xx>0&xxx<0)||(xx<0&xxx>0)
			sum(abs(xx[temp1]+xxx[temp1]))+sum(abs(xx[temp2]-xxx[temp2]+2*xx[temp2]*xxx[temp2]/(xx[temp2]-xxx[temp2])))
		})
	})
	diag(x.d) = Inf
	x.d.temp = x.d
	result = matrix(rep(0, p*(p+1)),p)
	for(i in 1:p){
		x.d = x.d.temp
		result[i,1] = i
		for(j in 2:(p)){
			#print(x.d)
			result[i,p+1] = result[i,p+1]+sort(x.d[result[i,j-1],])[1]
			result[i,j] = order(x.d[result[i,j-1],])[1]
			#x.d[i,]=Inf
			#x.d[j,]=Inf
			x.d[,i]=Inf
			x.d[,result[i,j]]=Inf
		}
		
	}
	result[order(result[,p+1])[1], -(p+1)]
}
