.First.lib <- function(lib, pkg)
{
    library.dynam("dad", pkg, lib)
    
    assign("?",
function (e1, e2)
{
    if (class(e1) == "dad") {
        help.dad(e1)
    }
    else {
        e1Expr <- substitute(e1)
        if (missing(e2)) {
            if (is.call(e1Expr))
                return(.helpForCall(e1Expr, parent.frame()))
            if (is.name(e1Expr))
                e1 <- as.character(e1Expr)
            eval(substitute(help(TOPIC), list(TOPIC = e1)))
        }
        else {
            if (is.name(e1Expr))
                e1 <- as.character(e1Expr)
            e2Expr <- substitute(e2)
            if (is.name(e2Expr))
                e2 <- as.character(e2Expr)
            else if (is.call(e2Expr) && identical(e1, "method"))
                return(.helpForCall(e2Expr, parent.frame(), FALSE))
            topic <- topicName(e1, e2)
            doHelp <- .tryHelp(topic)
            if (inherits(doHelp, "try-error")) {
                stop(gettextf("no documentation of type '%s' and topic '%s' (or error in processing help)", e1, e2), domain = NA)
            }
        }
    }
}
, match("package:dad", search()))

    DandDOptions = DandDoptions()
    DandDoptions(Server = DandDOptions$Server[1])
    lapply(as.list(rev(DandDOptions$SearchList)), attachDandD)
    print(.DandDOptions[1:2])
    cat("DandD Instances are attached on the search list.\n\n")
    print(.DandDOptions[3])
    #cat("dandD Instances are attached on the search list.\n")
}
