\name{createInstance}
\alias{createInstance}
\title{Create DandD instance on DandD Server}
\description{
  Function to create DandD instance on DandD Server.
}
\usage{
createInstance(dataFrame)
}
\arguments{
  \item{dataFrame}{\code{data.frame} object.}
}
\details{
  This function creates DandD instance from \code{data.frame} 
  on DandD Server.
}
\seealso{
  \code{\link{DandD}}, \code{\link{getInstance}}.
}

\examples{
test.d=data.frame(v1=c(1,2),v2=c("a","b"))
createInstance(test.d)
getInstance()
}
\keyword{DandD}
\keyword{dad}
\keyword{open}
\keyword{close}
