\name{getInstance}
\alias{getInstance}
\title{Get DandD instance on DandD Server}
\description{
  Function to get DandD instance loaded in DandD Server.
}
\usage{
getInstance(file = NULL)
}
\arguments{
  \item{file}{character string naming a file. If null, output to the console}
}
\details{
  This function flush DandD instance loaded in DandD Server 
  as a local directory file or console.
}
\seealso{
  \code{\link{DandD}}, \code{\link{createInstance}}.
}

\examples{
obj=DandD("AcidRain.dad")  #``AcidRain.dad'' is loaded on DandD Server
getInstance()
}
\keyword{DandD}
\keyword{dad}
\keyword{open}
\keyword{close}
